"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");
Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.fontFamily = exports.TOOLTIP_DEFAULT_PROPS = exports.TOOLBOX_DEFAULT_PROPS = exports.TITLE_STYLE = exports.STRAIGHT_LINE_ICON = exports.PictorialWrapper = exports.MIN_WIDTH = exports.LEGEND_STYLE = exports.GaugeLegendContent = exports.GaugeLegendContainer = exports.GaugeLegend = exports.GaugeIconContainer = exports.GaugeCircle = exports.DonutWrapper = exports.DASHED_LINE_ICON = exports.CsvDownloadButton = exports.ChartWrapper = exports.ChartTitle = exports.ChartStorieWrapper = exports.ChartContainer = exports.COMMON_STYLE = exports.CHART_WIDTH = exports.CHART_HEIGHT = exports.AXIS_SPLIT_LINE = void 0;
var _taggedTemplateLiteral2 = _interopRequireDefault(require("@babel/runtime/helpers/taggedTemplateLiteral"));
var _defineProperty2 = _interopRequireDefault(require("@babel/runtime/helpers/defineProperty"));
var _styled = _interopRequireDefault(require("@emotion/styled"));
var _theme = require("flipper-ui/theme");
var _templateObject, _templateObject2, _templateObject3, _templateObject4, _templateObject5, _templateObject6, _templateObject7, _templateObject8, _templateObject9, _templateObject0, _templateObject1, _templateObject10;
function ownKeys(e, r) { var t = Object.keys(e); if (Object.getOwnPropertySymbols) { var o = Object.getOwnPropertySymbols(e); r && (o = o.filter(function (r) { return Object.getOwnPropertyDescriptor(e, r).enumerable; })), t.push.apply(t, o); } return t; }
function _objectSpread(e) { for (var r = 1; r < arguments.length; r++) { var t = null != arguments[r] ? arguments[r] : {}; r % 2 ? ownKeys(Object(t), !0).forEach(function (r) { (0, _defineProperty2["default"])(e, r, t[r]); }) : Object.getOwnPropertyDescriptors ? Object.defineProperties(e, Object.getOwnPropertyDescriptors(t)) : ownKeys(Object(t)).forEach(function (r) { Object.defineProperty(e, r, Object.getOwnPropertyDescriptor(t, r)); }); } return e; }
var _theme$colors = _theme.theme.colors,
  gray = _theme$colors.gray,
  neutral = _theme$colors.neutral;
var STRAIGHT_LINE_ICON = exports.STRAIGHT_LINE_ICON = 'path://M0 0H25H50V2H25H0V0Z';
var DASHED_LINE_ICON = exports.DASHED_LINE_ICON = 'path://M180 1000 l0 -40 200 0 200 0 0 40 0 40 -200 0 -200 0 0 -40z, M810 ' + '1000 l0 -40 200 0 200 0 0 40 0 40 -200 0 -200 0 0 -40zm, M1440 1000 l0 ' + '-40 200 0 200 0 0 40 0 40 -200 0 -200 0 0 -40z';
var MIN_WIDTH = exports.MIN_WIDTH = {
  minWidth: '100%'
};
var CHART_WIDTH = exports.CHART_WIDTH = {
  width: '99.9%'
};
var CHART_HEIGHT = exports.CHART_HEIGHT = {
  width: '99.9%',
  height: 300
};
var fontFamily = exports.fontFamily = 'Roboto, Helvetica, Arial, sans-serif';
var TOOLBOX_DEFAULT_PROPS = exports.TOOLBOX_DEFAULT_PROPS = {
  showTitle: false,
  right: '9.52%'
};
var TOOLTIP_DEFAULT_PROPS = exports.TOOLTIP_DEFAULT_PROPS = {
  show: true,
  backgroundColor: "".concat(neutral[200], "90"),
  extraCssText: 'border: none; padding: 6px;',
  textStyle: {
    fontSize: 11.5,
    color: neutral[50],
    fontFamily: fontFamily
  }
};
var COMMON_STYLE = exports.COMMON_STYLE = {
  fontWeight: 400,
  color: neutral[200],
  fontFamily: fontFamily
};
var LEGEND_STYLE = exports.LEGEND_STYLE = _objectSpread({
  fontSize: 11.5
}, COMMON_STYLE);
var TITLE_STYLE = exports.TITLE_STYLE = _objectSpread({
  fontSize: 16
}, COMMON_STYLE);
var AXIS_SPLIT_LINE = exports.AXIS_SPLIT_LINE = {
  type: 'dashed',
  opacity: 0.2,
  color: gray[800]
};
var PictorialWrapper = exports.PictorialWrapper = _styled["default"].div(_templateObject || (_templateObject = (0, _taggedTemplateLiteral2["default"])(["\n    width: 330px;\n    margin: 0 auto;\n"])));
var DonutWrapper = exports.DonutWrapper = _styled["default"].div(_templateObject2 || (_templateObject2 = (0, _taggedTemplateLiteral2["default"])(["\n    width: 500px;\n    margin: 0 auto;\n"])));
var ChartStorieWrapper = exports.ChartStorieWrapper = _styled["default"].div(_templateObject3 || (_templateObject3 = (0, _taggedTemplateLiteral2["default"])(["\n    width: 50%;\n    margin: 0 auto;\n"])));
var ChartContainer = exports.ChartContainer = _styled["default"].div(_templateObject4 || (_templateObject4 = (0, _taggedTemplateLiteral2["default"])(["\n    width: 100%;\n"])));
var ChartWrapper = exports.ChartWrapper = _styled["default"].div(_templateObject5 || (_templateObject5 = (0, _taggedTemplateLiteral2["default"])(["\n    width: 100%;\n    position: relative;\n"])));
var ChartTitle = exports.ChartTitle = _styled["default"].h1(_templateObject6 || (_templateObject6 = (0, _taggedTemplateLiteral2["default"])(["\n    font-family: Roboto, Helvetica, Arial, sans-serif;\n    color: ", ";\n    top: 5;\n    margin: 0px;\n    font-size: 16px;\n    font-weight: 400;\n    position: absolute;\n"])), neutral[200]);
var GaugeLegendContainer = exports.GaugeLegendContainer = _styled["default"].div(_templateObject7 || (_templateObject7 = (0, _taggedTemplateLiteral2["default"])(["\n    display: flex;\n    gap: 12px;\n    align-items: center;\n    justify-content: center;\n"])));
var GaugeLegendContent = exports.GaugeLegendContent = _styled["default"].div(_templateObject8 || (_templateObject8 = (0, _taggedTemplateLiteral2["default"])(["\n    min-width: 44px;\n    min-height: 100px;\n    display: flex;\n    flex-direction: column;\n    align-items: center;\n    gap: 6px;\n    font-family: Roboto, Helvetica, Arial, sans-serif;\n"])));
var GaugeIconContainer = exports.GaugeIconContainer = _styled["default"].div(_templateObject9 || (_templateObject9 = (0, _taggedTemplateLiteral2["default"])(["\n    display: flex;\n    align-items: center;\n    justify-content: center;\n    min-width: 40px;\n    min-height: 44px;\n"])));
var GaugeCircle = exports.GaugeCircle = _styled["default"].div(_templateObject0 || (_templateObject0 = (0, _taggedTemplateLiteral2["default"])(["\n    width: 20px;\n    height: 20px;\n    margin: 4px 0;\n    border-radius: 100%;\n    background-color: ", ";\n"])), function (props) {
  return props.color;
});
var GaugeLegend = exports.GaugeLegend = _styled["default"].div(_templateObject1 || (_templateObject1 = (0, _taggedTemplateLiteral2["default"])(["\n    font-size: 14px;\n"])));
var CsvDownloadButton = exports.CsvDownloadButton = _styled["default"].button(_templateObject10 || (_templateObject10 = (0, _taggedTemplateLiteral2["default"])(["\n    font-weight: bold;\n    background: ", ";\n    text-transform: uppercase;\n    border: none;\n    width: 40px;\n    height: 20px;\n    cursor: pointer;\n    display: block;\n    position: absolute;\n    margin-top: -295px;\n    margin-left: 80%;\n\n    &:hover::after {\n        content: 'Save as CSV';\n        position: absolute;\n        text-transform: none;\n        font-weight: lighter;\n        top: 123%;\n        left: 50%;\n        transform: translateX(-50%);\n        background-color: ", ";\n        opacity: 55%;\n        color: ", ";\n        padding: 4px 8px;\n        border-radius: 4px;\n        font-size: 12px;\n        height: 19px;\n        white-space: nowrap;\n        text-align: center;\n        display: flex;\n        align-items: center;\n    }\n"])), neutral[50], neutral[200], neutral[50]);