"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");
var _typeof3 = require("@babel/runtime/helpers/typeof");
Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;
var _defineProperty2 = _interopRequireDefault(require("@babel/runtime/helpers/defineProperty"));
var _typeof2 = _interopRequireDefault(require("@babel/runtime/helpers/typeof"));
var _react = _interopRequireDefault(require("react"));
var _charts = require("echarts/charts");
var _components = require("echarts/components");
var echarts = _interopRequireWildcard(require("echarts/core"));
var _renderers = require("echarts/renderers");
var _core2 = _interopRequireDefault(require("echarts-for-react/lib/core"));
var _auxiliarFunctions = require("../../lib/auxiliarFunctions");
var _commonStyles = require("../../commonStyles");
var _theme = require("flipper-ui/theme");
function _interopRequireWildcard(e, t) { if ("function" == typeof WeakMap) var r = new WeakMap(), n = new WeakMap(); return (_interopRequireWildcard = function _interopRequireWildcard(e, t) { if (!t && e && e.__esModule) return e; var o, i, f = { __proto__: null, "default": e }; if (null === e || "object" != _typeof3(e) && "function" != typeof e) return f; if (o = t ? n : r) { if (o.has(e)) return o.get(e); o.set(e, f); } for (var _t in e) "default" !== _t && {}.hasOwnProperty.call(e, _t) && ((i = (o = Object.defineProperty) && Object.getOwnPropertyDescriptor(e, _t)) && (i.get || i.set) ? o(f, _t, i) : f[_t] = e[_t]); return f; })(e, t); }
function ownKeys(e, r) { var t = Object.keys(e); if (Object.getOwnPropertySymbols) { var o = Object.getOwnPropertySymbols(e); r && (o = o.filter(function (r) { return Object.getOwnPropertyDescriptor(e, r).enumerable; })), t.push.apply(t, o); } return t; }
function _objectSpread(e) { for (var r = 1; r < arguments.length; r++) { var t = null != arguments[r] ? arguments[r] : {}; r % 2 ? ownKeys(Object(t), !0).forEach(function (r) { (0, _defineProperty2["default"])(e, r, t[r]); }) : Object.getOwnPropertyDescriptors ? Object.defineProperties(e, Object.getOwnPropertyDescriptors(t)) : ownKeys(Object(t)).forEach(function (r) { Object.defineProperty(e, r, Object.getOwnPropertyDescriptor(t, r)); }); } return e; }
var _theme$colors = _theme.theme.colors,
  blue = _theme$colors.blue,
  neutral = _theme$colors.neutral;
echarts.use([_components.GridComponent, _components.TitleComponent, _renderers.CanvasRenderer, _components.LegendComponent, _components.TooltipComponent, _components.ToolboxComponent, _charts.LineChart, _components.DataZoomInsideComponent, _components.DataZoomSliderComponent]);
var AreaChart = function AreaChart(props) {
  var _toolboxTooltip$saveA, _toolboxTooltip$dataV;
  var data = props.data,
    grid = props.grid,
    color = props.color,
    width = props.width,
    title = props.title,
    yType = props.yType,
    xType = props.xType,
    tooltip = props.tooltip,
    dateFormat = props.dateFormat,
    yComplement = props.yComplement,
    rotateLabel = props.rotateLabel,
    scrollStart = props.scrollStart,
    fontLabelSize = props.fontLabelSize,
    toolboxTooltip = props.toolboxTooltip,
    tooltipComplement = props.tooltipComplement,
    _props$lineMarkName = props.lineMarkName,
    lineMarkName = _props$lineMarkName === void 0 ? '' : _props$lineMarkName,
    _props$lineMarkValue = props.lineMarkValue,
    lineMarkValue = _props$lineMarkValue === void 0 ? 0 : _props$lineMarkValue,
    _props$lineMarkColor = props.lineMarkColor,
    lineMarkColor = _props$lineMarkColor === void 0 ? '' : _props$lineMarkColor;
  var xData = data.map(function (item) {
    return item.label;
  });
  var chartData = data.map(function (item) {
    return item.result;
  });
  var markLineData = lineMarkValue && xData.map(function () {
    return lineMarkValue;
  });
  var formatDinamicLabel = function formatDinamicLabel(chartValues) {
    var data = chartValues.data;
    return yType === 'time' ? (0, _auxiliarFunctions.timeConvert)(Number(data)).toString() + 'h' : (0, _auxiliarFunctions.takeLabelComplement)(Number(data), yComplement !== null && yComplement !== void 0 ? yComplement : '').toString();
  };
  var formatSingleTooltip = function formatSingleTooltip(chartValues) {
    var _chartValues$ = chartValues[0],
      axisValueLabel = _chartValues$.axisValueLabel,
      data = _chartValues$.data;
    var label = tooltip === null || tooltip === void 0 ? void 0 : tooltip.label;
    var result = tooltip === null || tooltip === void 0 ? void 0 : tooltip.result;
    var complement = tooltipComplement ? tooltipComplement : '';
    var values = yType === 'time' ? (0, _auxiliarFunctions.timeConvert)(Number(data)) + 'h' : (0, _auxiliarFunctions.takeLabelComplement)(Number(data), yComplement !== null && yComplement !== void 0 ? yComplement : '').toString();
    return "".concat(label, ": ").concat((0, _auxiliarFunctions.formatTooltip)(axisValueLabel, dateFormat), " <br>\n      ").concat(result, ": ").concat(values, " <br>\n      ").concat(complement);
  };
  var formatLabel = function formatLabel(item) {
    var data = item.data;
    if (typeof yComplement === 'function' && (0, _typeof2["default"])(item) === 'object') {
      return yComplement(item.data);
    }
    if (typeof yComplement === 'function') {
      return yComplement;
    }
    if (yType === 'time') {
      return (0, _auxiliarFunctions.timeConvert)(Number(data)).toString() + 'h';
    }
    return (0, _auxiliarFunctions.takeLabelComplement)(Number(data), '').toString();
  };
  var dinamicData = function dinamicData(item, charts) {
    var isTime = yType === 'time' ? 3400 : 4500;
    var dataRange = item.end - item.start;
    var dataLimit = scrollStart ? (scrollStart * 100 + 400) / xData.length : isTime / xData.length;
    if (dataRange < dataLimit) {
      return charts.setOption({
        series: [{
          label: {
            show: true,
            distance: 1.1,
            color: neutral[200],
            formatter: formatDinamicLabel,
            fontSize: yType === 'time' ? 10 : 11.5
          }
        }]
      });
    }
    charts.setOption({
      series: [{
        label: {
          show: false
        }
      }]
    });
  };
  var series = {
    type: 'line',
    data: chartData,
    label: _objectSpread({
      show: true,
      distance: 1.1,
      formatter: formatLabel,
      fontSize: yType === 'time' ? 10 : 11.5
    }, _commonStyles.COMMON_STYLE),
    itemStyle: {
      color: color
    },
    lineStyle: {
      color: color || blue[800]
    },
    areaStyle: {
      opacity: 0.2,
      color: color || blue[800]
    }
  };
  var seriesMarkLine = {
    type: 'line',
    symbolSize: 0,
    showSymbol: false,
    data: markLineData,
    name: lineMarkName,
    emphasis: {
      scale: false
    },
    lineStyle: {
      width: 2,
      color: lineMarkColor
    }
  };
  var zoomEvent = {
    dataZoom: dinamicData
  };
  var arrayInitialSize = scrollStart || (dateFormat === 'yyyy-MM' ? 12 : 30);
  var tooltipLabelFormat = dateFormat === 'yyyy-MM' ? 'MMM/yy' : 'dd/MM/yyyy';
  var scrollable = xData.length > arrayInitialSize ? [{
    type: 'inside',
    end: 100,
    zoomLock: true,
    zoomOnMouseWheel: 'shift',
    start: (0, _auxiliarFunctions.getInitialValues)(xData.length, dateFormat, scrollStart)
  }, {
    type: 'slider',
    show: true,
    bottom: 10,
    end: 100,
    start: (0, _auxiliarFunctions.getInitialValues)(xData.length, dateFormat, scrollStart),
    labelFormatter: function labelFormatter(_, item) {
      return (0, _auxiliarFunctions.formatTime)(item, tooltipLabelFormat);
    }
  }] : [];
  var toolbox = toolboxTooltip && _objectSpread(_objectSpread({}, _commonStyles.TOOLBOX_DEFAULT_PROPS), {}, {
    feature: {
      saveAsImage: toolboxTooltip.saveAsImage && (0, _auxiliarFunctions.getSaveAsImage)((_toolboxTooltip$saveA = toolboxTooltip.saveAsImage.title) !== null && _toolboxTooltip$saveA !== void 0 ? _toolboxTooltip$saveA : ''),
      dataView: toolboxTooltip.dataView && (0, _auxiliarFunctions.getDataView)((_toolboxTooltip$dataV = toolboxTooltip.dataView.title) !== null && _toolboxTooltip$dataV !== void 0 ? _toolboxTooltip$dataV : '')
    }
  });
  var options = function options() {
    return {
      dataZoom: scrollable,
      color: [lineMarkColor],
      series: [series, seriesMarkLine],
      grid: _objectSpread(_objectSpread({}, grid || {
        bottom: 75
      }), {}, {
        show: true
      }),
      title: {
        text: title,
        left: '6.2%',
        textStyle: _objectSpread({}, _commonStyles.TITLE_STYLE)
      },
      xAxis: {
        type: 'category',
        data: xData,
        boundaryGap: false,
        splitLine: {
          show: true,
          lineStyle: _objectSpread({}, _commonStyles.AXIS_SPLIT_LINE)
        },
        axisLabel: _objectSpread(_objectSpread({}, _commonStyles.COMMON_STYLE), {}, {
          rotate: rotateLabel || 0,
          fontSize: fontLabelSize || 11.5,
          formatter: function formatter(item) {
            return xType === 'time' ? (0, _auxiliarFunctions.formatTime)(item, (0, _auxiliarFunctions.getDateFormatType)(dateFormat || 'yyyy-MM')) : item;
          }
        })
      },
      yAxis: {
        type: 'value',
        splitLine: {
          show: true,
          lineStyle: _objectSpread({}, _commonStyles.AXIS_SPLIT_LINE)
        },
        axisTick: {
          show: true
        },
        axisLine: {
          show: true,
          type: 'dashed',
          lineStyle: {
            color: neutral[200]
          }
        },
        axisLabel: _objectSpread(_objectSpread({}, _commonStyles.COMMON_STYLE), {}, {
          fontSize: fontLabelSize || 11.5,
          margin: yType === 'time' ? 16 : 14,
          formatter: function formatter(item) {
            return yType === 'time' ? (0, _auxiliarFunctions.timeConvert)(item) + 'h' : (0, _auxiliarFunctions.takeLabelComplement)(item, yComplement !== null && yComplement !== void 0 ? yComplement : '').toString();
          }
        }),
        max: lineMarkValue ? _auxiliarFunctions.fixedDomain : _auxiliarFunctions.getDomain
      },
      legend: {
        top: 30,
        icon: _commonStyles.STRAIGHT_LINE_ICON,
        textStyle: _objectSpread({}, _commonStyles.COMMON_STYLE)
      },
      tooltip: tooltip && _objectSpread({
        trigger: 'axis',
        formatter: formatSingleTooltip
      }, _commonStyles.TOOLTIP_DEFAULT_PROPS),
      toolbox: _objectSpread(_objectSpread({}, toolbox), {}, {
        tooltip: _objectSpread(_objectSpread({}, _commonStyles.TOOLTIP_DEFAULT_PROPS), {}, {
          formatter: function formatter(param) {
            return "<div>".concat(param.title, "</div>");
          }
        })
      })
    };
  };
  return /*#__PURE__*/_react["default"].createElement(_core2["default"], {
    notMerge: true,
    lazyUpdate: true,
    echarts: echarts,
    option: options(),
    style: {
      width: '99.9%',
      height: 300
    },
    opts: {
      renderer: 'canvas',
      width: width !== null && width !== void 0 ? width : 'auto'
    },
    onEvents: zoomEvent
  });
};
var _default = exports["default"] = AreaChart;