import React from 'react';
import type { IDefaultChartProps, TAudiometryDataEntry, AudiometryDataTooltip, LineStyleType, TSimpleLegend } from '../types';
export interface IProps extends Omit<IDefaultChartProps, 'data'> {
    height?: number;
    colors?: string[];
    legendGap?: number;
    symbolsSize?: number;
    legendPadding?: number;
    tooltipMarker?: boolean;
    legendItemWidth?: number;
    legendItemHeight?: number;
    lineType?: LineStyleType;
    legends?: TSimpleLegend[];
    data: TAudiometryDataEntry[][];
    legendType?: 'scroll' | 'plain';
    legendsPosition?: 'top' | 'bottom';
    formatTooltip?(items: AudiometryDataTooltip[]): string;
}
declare const AudiometryChart: (props: IProps) => React.JSX.Element;
export default AudiometryChart;
