"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");
var _typeof = require("@babel/runtime/helpers/typeof");
Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;
var _defineProperty2 = _interopRequireDefault(require("@babel/runtime/helpers/defineProperty"));
var _toConsumableArray2 = _interopRequireDefault(require("@babel/runtime/helpers/toConsumableArray"));
var _slicedToArray2 = _interopRequireDefault(require("@babel/runtime/helpers/slicedToArray"));
var _react = _interopRequireWildcard(require("react"));
var _charts = require("echarts/charts");
var _components = require("echarts/components");
var echarts = _interopRequireWildcard(require("echarts/core"));
var _renderers = require("echarts/renderers");
var _core2 = _interopRequireDefault(require("echarts-for-react/lib/core"));
var _ramda = require("ramda");
var _auxiliarFunctions = require("../../lib/auxiliarFunctions");
var _commonStyles = require("../../commonStyles");
var _theme = require("flipper-ui/theme");
function _interopRequireWildcard(e, t) { if ("function" == typeof WeakMap) var r = new WeakMap(), n = new WeakMap(); return (_interopRequireWildcard = function _interopRequireWildcard(e, t) { if (!t && e && e.__esModule) return e; var o, i, f = { __proto__: null, "default": e }; if (null === e || "object" != _typeof(e) && "function" != typeof e) return f; if (o = t ? n : r) { if (o.has(e)) return o.get(e); o.set(e, f); } for (var _t in e) "default" !== _t && {}.hasOwnProperty.call(e, _t) && ((i = (o = Object.defineProperty) && Object.getOwnPropertyDescriptor(e, _t)) && (i.get || i.set) ? o(f, _t, i) : f[_t] = e[_t]); return f; })(e, t); }
function ownKeys(e, r) { var t = Object.keys(e); if (Object.getOwnPropertySymbols) { var o = Object.getOwnPropertySymbols(e); r && (o = o.filter(function (r) { return Object.getOwnPropertyDescriptor(e, r).enumerable; })), t.push.apply(t, o); } return t; }
function _objectSpread(e) { for (var r = 1; r < arguments.length; r++) { var t = null != arguments[r] ? arguments[r] : {}; r % 2 ? ownKeys(Object(t), !0).forEach(function (r) { (0, _defineProperty2["default"])(e, r, t[r]); }) : Object.getOwnPropertyDescriptors ? Object.defineProperties(e, Object.getOwnPropertyDescriptors(t)) : ownKeys(Object(t)).forEach(function (r) { Object.defineProperty(e, r, Object.getOwnPropertyDescriptor(t, r)); }); } return e; }
var red = _theme.theme.colors.red;
echarts.use([_components.GridComponent, _components.TitleComponent, _renderers.CanvasRenderer, _components.LegendComponent, _components.TooltipComponent, _components.ToolboxComponent, _charts.LineChart, _charts.ScatterChart]);
var AudiometryChart = function AudiometryChart(props) {
  var _toolboxTooltip$saveA, _toolboxTooltip$saveA2, _toolboxTooltip$dataV;
  var data = props.data,
    grid = props.grid,
    color = props.color,
    title = props.title,
    width = props.width,
    height = props.height,
    colors = props.colors,
    legends = props.legends,
    lineType = props.lineType,
    legendGap = props.legendGap,
    legendType = props.legendType,
    symbolsSize = props.symbolsSize,
    tooltipMarker = props.tooltipMarker,
    legendPadding = props.legendPadding,
    toolboxTooltip = props.toolboxTooltip,
    legendsPosition = props.legendsPosition,
    legendItemWidth = props.legendItemWidth,
    legendItemHeight = props.legendItemHeight,
    formatTooltip = props.formatTooltip;
  var _useState = (0, _react.useState)(false),
    _useState2 = (0, _slicedToArray2["default"])(_useState, 2),
    showTitle = _useState2[0],
    setShowTitle = _useState2[1];
  var xData = ['.25', '.5', '1', '2', '3', '4', '6', '8'];
  (0, _react.useEffect)(function () {
    if (toolboxTooltip !== null && toolboxTooltip !== void 0 && toolboxTooltip.saveAsImageWithTitle) {
      setShowTitle(false);
    } else {
      setShowTitle(true);
    }
  }, [toolboxTooltip]);
  var handleShowTitle = function handleShowTitle(show) {
    setShowTitle(show);
  };
  var defaultTooltip = function defaultTooltip(items) {
    if (legends) {
      var generateTooltip = items.map(function (item) {
        var marker = tooltipMarker ? item.marker : '';
        return "".concat(marker, " ").concat(item.seriesName, ": ").concat(item.data.value, " dB <br>");
      });
      return generateTooltip.join(' ');
    }
    // TODO: remove this default tooltip to turn it generic
    var item = items.length > 0 ? items[0].data : {
      value: 0,
      boneValue: 0
    };
    var result = item.value || item.value === 0 ? "Limiar A\xE9reo: ".concat(item.value, " dB <br>") : '';
    var boneResult = item.boneValue || item.boneValue === 0 ? "Limiar \xD3sseo: ".concat(item.boneValue, " dB") : '';
    return result + boneResult;
  };
  var takeYData = function takeYData(item) {
    return item.map(function (item) {
      return {
        name: item.result,
        value: item.result,
        symbol: item.symbol,
        symbolSize: symbolsSize || 12,
        boneValue: item.boneResult
      };
    });
  };
  var takeMarks = function takeMarks(item) {
    return (0, _ramda.zipWith)(function (_, data) {
      return data.boneSymbol ? {
        value: data.boneResult,
        symbol: data.boneSymbol,
        symbolSize: symbolsSize || 12
      } : {};
    }, xData, item);
  };
  var seriesMarks = data.map(function (item) {
    return {
      data: takeMarks(item)
    };
  });
  var removedUndefinedMarks = seriesMarks.map(function (item) {
    return item.data.filter(function (serie) {
      return serie.value !== undefined;
    });
  });
  var marksWithTypes = removedUndefinedMarks.filter(function (item) {
    return item.length > 0;
  }).map(function (item) {
    return {
      name: 'marks',
      type: 'scatter',
      data: item
    };
  });
  var seriesData = data.map(function (item) {
    return {
      type: 'line',
      data: takeYData(item),
      lineStyle: {
        width: 1,
        type: lineType || 'solid'
      }
    };
  });
  var series = [].concat((0, _toConsumableArray2["default"])(marksWithTypes), (0, _toConsumableArray2["default"])(seriesData)).map(function (item, index) {
    return _objectSpread(_objectSpread({}, item), {}, {
      name: legends && legends.length > 0 ? legends[index].name : 'audiometry-' + index
    });
  });
  var legendProps = legendsPosition === 'bottom' ? {
    top: 340,
    data: legends,
    type: legendType,
    itemGap: legendGap || 5,
    padding: legendPadding || 4,
    itemWidth: legendItemWidth || 25,
    itemHeight: legendItemHeight || 14,
    textStyle: _objectSpread({}, _commonStyles.LEGEND_STYLE)
  } : {
    top: 30,
    itemGap: 30,
    data: legends,
    textStyle: _objectSpread({}, _commonStyles.LEGEND_STYLE)
  };
  var myTool = (toolboxTooltip === null || toolboxTooltip === void 0 ? void 0 : toolboxTooltip.saveAsImageWithTitle) && {
    myTool: (0, _auxiliarFunctions.getSaveAsImageWithTitle)((_toolboxTooltip$saveA = toolboxTooltip.saveAsImageWithTitle.title) !== null && _toolboxTooltip$saveA !== void 0 ? _toolboxTooltip$saveA : '', handleShowTitle)
  };
  var toolbox = toolboxTooltip && _objectSpread(_objectSpread({}, _commonStyles.TOOLBOX_DEFAULT_PROPS), {}, {
    feature: _objectSpread(_objectSpread({}, myTool), {}, {
      saveAsImage: toolboxTooltip.saveAsImage && (0, _auxiliarFunctions.getSaveAsImage)((_toolboxTooltip$saveA2 = toolboxTooltip.saveAsImage.title) !== null && _toolboxTooltip$saveA2 !== void 0 ? _toolboxTooltip$saveA2 : ''),
      dataView: toolboxTooltip.dataView && (0, _auxiliarFunctions.getDataView)((_toolboxTooltip$dataV = toolboxTooltip.dataView.title) !== null && _toolboxTooltip$dataV !== void 0 ? _toolboxTooltip$dataV : '')
    })
  });
  var options = function options() {
    return {
      color: colors,
      series: series,
      grid: _objectSpread(_objectSpread({}, grid), {}, {
        show: false
      }),
      title: {
        text: title,
        left: '6.2%',
        show: showTitle,
        textStyle: _objectSpread(_objectSpread({}, _commonStyles.TITLE_STYLE), {}, {
          color: color || red[600]
        })
      },
      xAxis: {
        type: 'category',
        data: xData,
        boundaryGap: true,
        splitLine: {
          show: true,
          alignWithLabel: true,
          lineStyle: {
            type: 'solid',
            opacity: 0.2,
            color: color || red[600]
          }
        },
        axisLine: {
          onZeroAxisIndex: 1,
          lineStyle: {
            color: color || red[600]
          }
        },
        axisLabel: {
          fontFamily: _commonStyles.fontFamily
        },
        axisTick: {
          show: true,
          alignWithLabel: true
        }
      },
      yAxis: {
        type: 'value',
        min: 0,
        max: 130,
        interval: 10,
        inverse: true,
        splitLine: {
          show: true,
          lineStyle: {
            type: 'solid',
            opacity: 0.2,
            color: color || red[600]
          }
        },
        axisLine: {
          show: true,
          onZero: true,
          lineStyle: {
            color: color || red[600]
          }
        },
        axisTick: {
          show: true
        },
        axisLabel: {
          fontFamily: _commonStyles.fontFamily
        }
      },
      legend: legends !== null && legends !== void 0 && legends.length ? legendProps : {
        show: false
      },
      tooltip: _objectSpread({
        trigger: 'axis',
        formatter: formatTooltip !== null && formatTooltip !== void 0 ? formatTooltip : defaultTooltip
      }, _commonStyles.TOOLTIP_DEFAULT_PROPS),
      toolbox: _objectSpread(_objectSpread({}, toolbox), {}, {
        tooltip: _objectSpread(_objectSpread({}, _commonStyles.TOOLTIP_DEFAULT_PROPS), {}, {
          formatter: function formatter(param) {
            return "<div>".concat(param.title, "</div>");
          }
        })
      })
    };
  };
  return /*#__PURE__*/_react["default"].createElement(_core2["default"], {
    notMerge: true,
    lazyUpdate: true,
    echarts: echarts,
    option: options(),
    style: {
      width: '99.9%',
      height: height || 400
    },
    opts: {
      renderer: 'canvas',
      width: width !== null && width !== void 0 ? width : 'auto'
    }
  });
};
var _default = exports["default"] = AudiometryChart;