"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");
var _typeof = require("@babel/runtime/helpers/typeof");
Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;
var _defineProperty2 = _interopRequireDefault(require("@babel/runtime/helpers/defineProperty"));
var _slicedToArray2 = _interopRequireDefault(require("@babel/runtime/helpers/slicedToArray"));
var _react = _interopRequireWildcard(require("react"));
var _charts = require("echarts/charts");
var _components = require("echarts/components");
var echarts = _interopRequireWildcard(require("echarts/core"));
var _renderers = require("echarts/renderers");
var _core2 = _interopRequireDefault(require("echarts-for-react/lib/core"));
var _auxiliarFunctions = require("../../lib/auxiliarFunctions");
var _commonStyles = require("../../commonStyles");
var _theme = require("flipper-ui/theme");
function _interopRequireWildcard(e, t) { if ("function" == typeof WeakMap) var r = new WeakMap(), n = new WeakMap(); return (_interopRequireWildcard = function _interopRequireWildcard(e, t) { if (!t && e && e.__esModule) return e; var o, i, f = { __proto__: null, "default": e }; if (null === e || "object" != _typeof(e) && "function" != typeof e) return f; if (o = t ? n : r) { if (o.has(e)) return o.get(e); o.set(e, f); } for (var _t in e) "default" !== _t && {}.hasOwnProperty.call(e, _t) && ((i = (o = Object.defineProperty) && Object.getOwnPropertyDescriptor(e, _t)) && (i.get || i.set) ? o(f, _t, i) : f[_t] = e[_t]); return f; })(e, t); }
function ownKeys(e, r) { var t = Object.keys(e); if (Object.getOwnPropertySymbols) { var o = Object.getOwnPropertySymbols(e); r && (o = o.filter(function (r) { return Object.getOwnPropertyDescriptor(e, r).enumerable; })), t.push.apply(t, o); } return t; }
function _objectSpread(e) { for (var r = 1; r < arguments.length; r++) { var t = null != arguments[r] ? arguments[r] : {}; r % 2 ? ownKeys(Object(t), !0).forEach(function (r) { (0, _defineProperty2["default"])(e, r, t[r]); }) : Object.getOwnPropertyDescriptors ? Object.defineProperties(e, Object.getOwnPropertyDescriptors(t)) : ownKeys(Object(t)).forEach(function (r) { Object.defineProperty(e, r, Object.getOwnPropertyDescriptor(t, r)); }); } return e; }
var _theme$colors = _theme.theme.colors,
  gray = _theme$colors.gray,
  neutral = _theme$colors.neutral;
echarts.use([_components.GridComponent, _components.TitleComponent, _renderers.CanvasRenderer, _components.LegendComponent, _components.TooltipComponent, _components.ToolboxComponent, _charts.LineChart]);
var CoordinateLineChart = function CoordinateLineChart(props) {
  var _legendNames$, _legendNames$2, _legendNames$3, _toolboxTooltip$saveA, _toolboxTooltip$saveA2, _toolboxTooltip$dataV;
  var grid = props.grid,
    title = props.title,
    width = props.width,
    height = props.height,
    colors = props.colors,
    xMaxValue = props.xMaxValue,
    legendNames = props.legendNames,
    coordinates = props.coordinates,
    yRangeValues = props.yRangeValues,
    legendPosition = props.legendPosition,
    toolboxTooltip = props.toolboxTooltip,
    coordinateNames = props.coordinateNames;
  var _coordinates = (0, _slicedToArray2["default"])(coordinates, 3),
    ref = _coordinates[0],
    pre = _coordinates[1],
    pos = _coordinates[2];
  var _useState = (0, _react.useState)(false),
    _useState2 = (0, _slicedToArray2["default"])(_useState, 2),
    showTitle = _useState2[0],
    setShowTitle = _useState2[1];
  (0, _react.useEffect)(function () {
    if (toolboxTooltip !== null && toolboxTooltip !== void 0 && toolboxTooltip.saveAsImageWithTitle) {
      setShowTitle(false);
    } else {
      setShowTitle(true);
    }
  }, [toolboxTooltip]);
  var handleShowTitle = function handleShowTitle(show) {
    setShowTitle(show);
  };
  var toTuples = function toTuples(args) {
    return args.map(function (item) {
      return [item.x, item.y];
    });
  };
  var reference = toTuples(ref);
  var preRespiratory = toTuples(pre);
  var posResporatory = toTuples(pos);
  var series = [{
    type: 'line',
    smooth: true,
    data: reference,
    showSymbol: false,
    name: (_legendNames$ = legendNames === null || legendNames === void 0 ? void 0 : legendNames[0]) !== null && _legendNames$ !== void 0 ? _legendNames$ : '',
    lineStyle: {
      width: 1.5,
      type: 'dashed'
    }
  }, {
    type: 'line',
    smooth: true,
    showSymbol: false,
    data: preRespiratory,
    name: (_legendNames$2 = legendNames === null || legendNames === void 0 ? void 0 : legendNames[1]) !== null && _legendNames$2 !== void 0 ? _legendNames$2 : ''
  }, {
    type: 'line',
    smooth: true,
    showSymbol: false,
    data: posResporatory,
    name: (_legendNames$3 = legendNames === null || legendNames === void 0 ? void 0 : legendNames[2]) !== null && _legendNames$3 !== void 0 ? _legendNames$3 : ''
  }];
  var myTool = (toolboxTooltip === null || toolboxTooltip === void 0 ? void 0 : toolboxTooltip.saveAsImageWithTitle) && {
    myTool: (0, _auxiliarFunctions.getSaveAsImageWithTitle)((_toolboxTooltip$saveA = toolboxTooltip.saveAsImageWithTitle.title) !== null && _toolboxTooltip$saveA !== void 0 ? _toolboxTooltip$saveA : '', handleShowTitle)
  };
  var toolbox = toolboxTooltip && _objectSpread(_objectSpread({}, _commonStyles.TOOLBOX_DEFAULT_PROPS), {}, {
    feature: _objectSpread(_objectSpread({}, myTool), {}, {
      saveAsImage: toolboxTooltip.saveAsImage && (0, _auxiliarFunctions.getSaveAsImage)((_toolboxTooltip$saveA2 = toolboxTooltip.saveAsImage.title) !== null && _toolboxTooltip$saveA2 !== void 0 ? _toolboxTooltip$saveA2 : ''),
      dataView: toolboxTooltip.dataView && (0, _auxiliarFunctions.getDataView)((_toolboxTooltip$dataV = toolboxTooltip.dataView.title) !== null && _toolboxTooltip$dataV !== void 0 ? _toolboxTooltip$dataV : '')
    })
  });
  var options = function options() {
    var _legendNames$4, _legendNames$5, _legendNames$6;
    return {
      color: colors,
      series: series,
      grid: _objectSpread(_objectSpread({}, grid), {}, {
        containLabel: true
      }),
      title: {
        text: title,
        left: '6.2%',
        show: showTitle,
        textStyle: _objectSpread({}, _commonStyles.TITLE_STYLE)
      },
      xAxis: {
        type: 'value',
        name: coordinateNames === null || coordinateNames === void 0 ? void 0 : coordinateNames.x,
        min: 0,
        max: xMaxValue || 8,
        interval: 2,
        nameGap: -56,
        nameTextStyle: _objectSpread(_objectSpread({}, _commonStyles.COMMON_STYLE), {}, {
          verticalAlign: 'top',
          padding: yRangeValues ? [150, 0, 0, 0] : [20, 0, 0, 0]
        }),
        splitLine: {
          show: true,
          lineStyle: {
            type: 'solid',
            opacity: 0.5,
            color: gray[800]
          }
        },
        axisTick: {
          show: false
        },
        axisLabel: _objectSpread({}, _commonStyles.COMMON_STYLE),
        axisLine: {
          lineStyle: {
            color: neutral[200]
          }
        }
      },
      yAxis: {
        type: 'value',
        name: coordinateNames === null || coordinateNames === void 0 ? void 0 : coordinateNames.y,
        min: yRangeValues ? -yRangeValues : 0,
        max: yRangeValues || 8,
        interval: 2,
        nameGap: 10,
        nameTextStyle: _objectSpread({}, _commonStyles.COMMON_STYLE),
        splitLine: {
          show: true,
          lineStyle: {
            type: 'solid',
            opacity: 0.5,
            color: gray[800]
          }
        },
        axisTick: {
          show: true
        },
        axisLabel: _objectSpread({}, _commonStyles.COMMON_STYLE),
        axisLine: {
          lineStyle: {
            color: neutral[200]
          }
        }
      },
      legend: {
        itemGap: 30,
        top: legendPosition !== null && legendPosition !== void 0 ? legendPosition : 26,
        textStyle: _objectSpread({}, _commonStyles.COMMON_STYLE),
        data: [{
          name: (_legendNames$4 = legendNames === null || legendNames === void 0 ? void 0 : legendNames[0]) !== null && _legendNames$4 !== void 0 ? _legendNames$4 : '',
          icon: _commonStyles.DASHED_LINE_ICON
        }, {
          name: (_legendNames$5 = legendNames === null || legendNames === void 0 ? void 0 : legendNames[1]) !== null && _legendNames$5 !== void 0 ? _legendNames$5 : '',
          icon: _commonStyles.STRAIGHT_LINE_ICON
        }, {
          name: (_legendNames$6 = legendNames === null || legendNames === void 0 ? void 0 : legendNames[2]) !== null && _legendNames$6 !== void 0 ? _legendNames$6 : '',
          icon: _commonStyles.STRAIGHT_LINE_ICON
        }]
      },
      tooltip: _objectSpread({
        trigger: 'none'
      }, _commonStyles.TOOLTIP_DEFAULT_PROPS),
      toolbox: _objectSpread(_objectSpread({}, toolbox), {}, {
        tooltip: _objectSpread(_objectSpread({}, _commonStyles.TOOLTIP_DEFAULT_PROPS), {}, {
          formatter: function formatter(param) {
            return "<div>".concat(param.title, "</div>");
          }
        })
      })
    };
  };
  return /*#__PURE__*/_react["default"].createElement(_core2["default"], {
    notMerge: true,
    lazyUpdate: true,
    echarts: echarts,
    option: options(),
    style: {
      width: 'auto',
      height: height
    },
    opts: {
      renderer: 'canvas',
      width: width !== null && width !== void 0 ? width : 'auto'
    }
  });
};
var _default = exports["default"] = CoordinateLineChart;