"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");
var _typeof = require("@babel/runtime/helpers/typeof");
Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;
var _regenerator = _interopRequireDefault(require("@babel/runtime/regenerator"));
var _toConsumableArray2 = _interopRequireDefault(require("@babel/runtime/helpers/toConsumableArray"));
var _defineProperty2 = _interopRequireDefault(require("@babel/runtime/helpers/defineProperty"));
var _asyncToGenerator2 = _interopRequireDefault(require("@babel/runtime/helpers/asyncToGenerator"));
var _slicedToArray2 = _interopRequireDefault(require("@babel/runtime/helpers/slicedToArray"));
var _react = _interopRequireWildcard(require("react"));
var _charts = require("echarts/charts");
var _components = require("echarts/components");
var echarts = _interopRequireWildcard(require("echarts/core"));
var _renderers = require("echarts/renderers");
var _core2 = _interopRequireDefault(require("echarts-for-react/lib/core"));
var _auxiliarFunctions = require("../../lib/auxiliarFunctions");
var _commonStyles = require("../../commonStyles");
var _theme = require("flipper-ui/theme");
function _interopRequireWildcard(e, t) { if ("function" == typeof WeakMap) var r = new WeakMap(), n = new WeakMap(); return (_interopRequireWildcard = function _interopRequireWildcard(e, t) { if (!t && e && e.__esModule) return e; var o, i, f = { __proto__: null, "default": e }; if (null === e || "object" != _typeof(e) && "function" != typeof e) return f; if (o = t ? n : r) { if (o.has(e)) return o.get(e); o.set(e, f); } for (var _t in e) "default" !== _t && {}.hasOwnProperty.call(e, _t) && ((i = (o = Object.defineProperty) && Object.getOwnPropertyDescriptor(e, _t)) && (i.get || i.set) ? o(f, _t, i) : f[_t] = e[_t]); return f; })(e, t); }
function ownKeys(e, r) { var t = Object.keys(e); if (Object.getOwnPropertySymbols) { var o = Object.getOwnPropertySymbols(e); r && (o = o.filter(function (r) { return Object.getOwnPropertyDescriptor(e, r).enumerable; })), t.push.apply(t, o); } return t; }
function _objectSpread(e) { for (var r = 1; r < arguments.length; r++) { var t = null != arguments[r] ? arguments[r] : {}; r % 2 ? ownKeys(Object(t), !0).forEach(function (r) { (0, _defineProperty2["default"])(e, r, t[r]); }) : Object.getOwnPropertyDescriptors ? Object.defineProperties(e, Object.getOwnPropertyDescriptors(t)) : ownKeys(Object(t)).forEach(function (r) { Object.defineProperty(e, r, Object.getOwnPropertyDescriptor(t, r)); }); } return e; }
var gray = _theme.theme.colors.gray;
echarts.use([_components.GridComponent, _components.TitleComponent, _renderers.CanvasRenderer, _components.LegendComponent, _components.TooltipComponent, _components.ToolboxComponent, _charts.BarChart]);
var DivergingStackedBarChart = function DivergingStackedBarChart(props) {
  var _toolboxTooltip$saveA, _toolboxTooltip$saveA2, _toolboxTooltip$dataV;
  var grid = props.grid,
    data = props.data,
    width = props.width,
    title = props.title,
    legendType = props.legendType,
    showTickInfos = props.showTickInfos,
    titleFontSize = props.titleFontSize,
    toolboxTooltip = props.toolboxTooltip,
    marginRightToolbox = props.marginRightToolbox,
    onClickBar = props.onClickBar;
  var _useState = (0, _react.useState)(false),
    _useState2 = (0, _slicedToArray2["default"])(_useState, 2),
    showTitle = _useState2[0],
    setShowTitle = _useState2[1];
  var _useState3 = (0, _react.useState)([]),
    _useState4 = (0, _slicedToArray2["default"])(_useState3, 2),
    richData = _useState4[0],
    setRichData = _useState4[1];
  var clickEvent = {
    click: onClickBar !== null && onClickBar !== void 0 ? onClickBar : function () {}
  };
  (0, _react.useEffect)(function () {
    if (toolboxTooltip !== null && toolboxTooltip !== void 0 && toolboxTooltip.saveAsImageWithTitle) {
      setShowTitle(false);
    } else {
      setShowTitle(true);
    }
  }, [toolboxTooltip]);
  (0, _react.useEffect)(function () {
    data.seriesData.map(/*#__PURE__*/function () {
      var _ref = (0, _asyncToGenerator2["default"])(/*#__PURE__*/_regenerator["default"].mark(function _callee(item) {
        var _item$label;
        var rich;
        return _regenerator["default"].wrap(function _callee$(_context) {
          while (1) switch (_context.prev = _context.next) {
            case 0:
              if (item.image) {
                _context.next = 2;
                break;
              }
              return _context.abrupt("return", {});
            case 2:
              _context.t0 = _defineProperty2["default"];
              _context.t1 = {};
              _context.t2 = (0, _auxiliarFunctions.changeSpaceForUnderline)((_item$label = item.label) !== null && _item$label !== void 0 ? _item$label : '');
              _context.next = 7;
              return (0, _auxiliarFunctions.convertImageToBase64FromUrl)(item.image);
            case 7:
              _context.t3 = _context.sent;
              _context.t4 = {
                image: _context.t3
              };
              _context.t5 = {
                height: 35,
                backgroundColor: _context.t4
              };
              rich = (0, _context.t0)(_context.t1, _context.t2, _context.t5);
              if (!richData.find(function (itemRich) {
                var _item$label2;
                return (0, _auxiliarFunctions.changeSpaceForUnderline)((_item$label2 = item.label) !== null && _item$label2 !== void 0 ? _item$label2 : '') in itemRich;
              })) {
                setRichData(function (state) {
                  return [].concat((0, _toConsumableArray2["default"])(state), [rich]);
                });
              }
            case 12:
            case "end":
              return _context.stop();
          }
        }, _callee);
      }));
      return function (_x) {
        return _ref.apply(this, arguments);
      };
    }());
  }, [richData]);
  var handleShowTitle = function handleShowTitle(show) {
    setShowTitle(show);
  };
  var formatTooltip = function formatTooltip(params) {
    var tooltipString = "<div style=\"margin-bottom: 6px\">\n                ".concat(params[0].axisValueLabel, "<br/>\n            </div>");
    var details = params.map(function (obj) {
      return "<div style=\"display: flex; align-items: center; margin-top: 4px;\">\n                    ".concat(obj.marker, "\n                    <div\n                        style=\"\n                            width: 100%;\n                            display: flex;\n                            justify-content: space-between;\n                            align-items: center;\">\n                        <div>\n                            ").concat(obj.seriesName, "\n                        </div>\n                        <div style=\"font-weight: 600; padding-left: 16px;\">\n                            ").concat(Math.abs(obj.value), "\n                        </div>\n                    </div>\n                </div>");
    }).join('');
    return tooltipString + details;
  };
  var exportToCSV = function exportToCSV() {
    var _props$data = props.data,
      seriesData = _props$data.seriesData,
      categories = _props$data.categories;
    var csvContent = 'data:text/csv;charset=utf-8,';
    csvContent += 'Category,' + seriesData.map(function (series) {
      return series.name;
    }).join(',') + '\r\n';
    for (var i = 0; i < categories.length; i++) {
      var row = [categories[i].toString()];
      for (var j = 0; j < seriesData.length; j++) {
        row.push(seriesData[j].data[i].toString());
      }
      csvContent += row.join(',') + '\r\n';
    }
    var encodedUri = encodeURI(csvContent);
    var link = document.createElement('a');
    link.setAttribute('href', encodedUri);
    link.setAttribute('download', 'chart_data.csv');
    document.body.appendChild(link);
    link.click();
    document.body.removeChild(link);
  };
  var series = data.seriesData.map(function (seriesItem) {
    return {
      type: 'bar',
      stack: 'Total',
      data: seriesItem.data,
      name: seriesItem.name,
      emphasis: {
        focus: 'series'
      },
      grid: _objectSpread({
        containLabel: true
      }, grid),
      label: {
        show: true,
        position: seriesItem.labelPosition || 'inside',
        formatter: function formatter(params) {
          return Math.abs(params.value);
        }
      },
      itemStyle: seriesItem.itemStyle || {
        color: seriesItem.color || props.color || gray[200]
      }
    };
  });
  var myTool = (toolboxTooltip === null || toolboxTooltip === void 0 ? void 0 : toolboxTooltip.saveAsImageWithTitle) && {
    myTool: (0, _auxiliarFunctions.getSaveAsImageWithTitle)((_toolboxTooltip$saveA = toolboxTooltip.saveAsImageWithTitle.title) !== null && _toolboxTooltip$saveA !== void 0 ? _toolboxTooltip$saveA : '', handleShowTitle)
  };
  var toolbox = toolboxTooltip && {
    showTitle: false,
    right: marginRightToolbox || '8.7%',
    feature: _objectSpread(_objectSpread({}, myTool), {}, {
      saveAsImage: toolboxTooltip.saveAsImage && (0, _auxiliarFunctions.getSaveAsImage)((_toolboxTooltip$saveA2 = toolboxTooltip.saveAsImage.title) !== null && _toolboxTooltip$saveA2 !== void 0 ? _toolboxTooltip$saveA2 : ''),
      dataView: toolboxTooltip.dataView && (0, _auxiliarFunctions.getDataView)((_toolboxTooltip$dataV = toolboxTooltip.dataView.title) !== null && _toolboxTooltip$dataV !== void 0 ? _toolboxTooltip$dataV : '')
    })
  };
  var options = function options() {
    return {
      series: series,
      grid: {
        left: '3%',
        right: '4%',
        bottom: '3%',
        containLabel: true
      },
      title: {
        text: title,
        show: showTitle,
        top: legendType,
        left: legendType === 'scroll' ? '0.1%' : '4%',
        textStyle: _objectSpread(_objectSpread({}, _commonStyles.TITLE_STYLE), {}, {
          fontSize: titleFontSize || 16
        })
      },
      splitLine: {
        show: showTickInfos || false,
        lineStyle: _objectSpread({}, _commonStyles.AXIS_SPLIT_LINE)
      },
      xAxis: [{
        type: 'value',
        axisLabel: {
          formatter: function formatter(value) {
            return Math.abs(value).toString();
          }
        }
      }],
      yAxis: [{
        type: 'category',
        data: data.categories,
        axisTick: {
          show: false
        }
      }],
      legend: {
        data: data.seriesData.map(function (item) {
          return item.name;
        })
      },
      tooltip: _objectSpread({
        trigger: 'axis',
        axisPointer: {
          type: 'shadow'
        },
        formatter: formatTooltip
      }, _commonStyles.TOOLTIP_DEFAULT_PROPS),
      toolbox: _objectSpread(_objectSpread({}, toolbox), {}, {
        tooltip: _objectSpread(_objectSpread({}, _commonStyles.TOOLTIP_DEFAULT_PROPS), {}, {
          formatter: function formatter(param) {
            return "<div>".concat(param.title, "</div>");
          }
        })
      })
    };
  };
  return /*#__PURE__*/_react["default"].createElement(_react["default"].Fragment, null, /*#__PURE__*/_react["default"].createElement(_core2["default"], {
    echarts: echarts,
    option: options(),
    style: {
      width: '99.9%'
    },
    opts: {
      renderer: 'canvas',
      width: width !== null && width !== void 0 ? width : 'auto'
    },
    onEvents: clickEvent
  }), props.showCSVDownload && /*#__PURE__*/_react["default"].createElement(_commonStyles.CsvDownloadButton, {
    onClick: exportToCSV
  }, "csv"));
};
var _default = exports["default"] = DivergingStackedBarChart;