"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");
var _typeof = require("@babel/runtime/helpers/typeof");
Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;
var _defineProperty2 = _interopRequireDefault(require("@babel/runtime/helpers/defineProperty"));
var _slicedToArray2 = _interopRequireDefault(require("@babel/runtime/helpers/slicedToArray"));
var _react = _interopRequireWildcard(require("react"));
var _charts = require("echarts/charts");
var _components = require("echarts/components");
var echarts = _interopRequireWildcard(require("echarts/core"));
var _renderers = require("echarts/renderers");
var _core2 = _interopRequireDefault(require("echarts-for-react/lib/core"));
var _auxiliarFunctions = require("../../lib/auxiliarFunctions");
var _commonStyles = require("../../commonStyles");
var _theme = require("flipper-ui/theme");
function _interopRequireWildcard(e, t) { if ("function" == typeof WeakMap) var r = new WeakMap(), n = new WeakMap(); return (_interopRequireWildcard = function _interopRequireWildcard(e, t) { if (!t && e && e.__esModule) return e; var o, i, f = { __proto__: null, "default": e }; if (null === e || "object" != _typeof(e) && "function" != typeof e) return f; if (o = t ? n : r) { if (o.has(e)) return o.get(e); o.set(e, f); } for (var _t in e) "default" !== _t && {}.hasOwnProperty.call(e, _t) && ((i = (o = Object.defineProperty) && Object.getOwnPropertyDescriptor(e, _t)) && (i.get || i.set) ? o(f, _t, i) : f[_t] = e[_t]); return f; })(e, t); }
function ownKeys(e, r) { var t = Object.keys(e); if (Object.getOwnPropertySymbols) { var o = Object.getOwnPropertySymbols(e); r && (o = o.filter(function (r) { return Object.getOwnPropertyDescriptor(e, r).enumerable; })), t.push.apply(t, o); } return t; }
function _objectSpread(e) { for (var r = 1; r < arguments.length; r++) { var t = null != arguments[r] ? arguments[r] : {}; r % 2 ? ownKeys(Object(t), !0).forEach(function (r) { (0, _defineProperty2["default"])(e, r, t[r]); }) : Object.getOwnPropertyDescriptors ? Object.defineProperties(e, Object.getOwnPropertyDescriptors(t)) : ownKeys(Object(t)).forEach(function (r) { Object.defineProperty(e, r, Object.getOwnPropertyDescriptor(t, r)); }); } return e; }
var neutral = _theme.theme.colors.neutral;
echarts.use([_components.GridComponent, _components.TitleComponent, _renderers.CanvasRenderer, _components.LegendComponent, _components.TooltipComponent, _components.ToolboxComponent, _charts.PieChart]);
var DonutChart = function DonutChart(props) {
  var _toolboxTooltip$saveA, _toolboxTooltip$saveA2, _toolboxTooltip$dataV;
  var data = props.data,
    grid = props.grid,
    width = props.width,
    title = props.title,
    colors = props.colors,
    center = props.center,
    tooltip = props.tooltip,
    legendType = props.legendType,
    donutRadius = props.donutRadius,
    yComplement = props.yComplement,
    selectedMode = props.selectedMode,
    labelFontColor = props.labelFontColor,
    legendPosition = props.legendPosition,
    toolboxTooltip = props.toolboxTooltip,
    pieceBorderColor = props.pieceBorderColor,
    resultFormatType = props.resultFormatType,
    donutCenterValue = props.donutCenterValue,
    centerPieValueFontSize = props.centerPieValueFontSize;
  var dataLegend = data.map(function (item) {
    return item.name;
  });
  var totalValues = data.reduce(function (acc, item) {
    return acc + item.value;
  }, 0);
  var _useState = (0, _react.useState)(false),
    _useState2 = (0, _slicedToArray2["default"])(_useState, 2),
    showTitle = _useState2[0],
    setShowTitle = _useState2[1];
  (0, _react.useEffect)(function () {
    if (toolboxTooltip !== null && toolboxTooltip !== void 0 && toolboxTooltip.saveAsImageWithTitle) {
      setShowTitle(false);
    } else {
      setShowTitle(true);
    }
  }, [toolboxTooltip]);
  var handleShowTitle = function handleShowTitle(show) {
    setShowTitle(show);
  };
  var formatTooltip = function formatTooltip(_ref) {
    var name = _ref.name,
      value = _ref.value,
      marker = _ref.marker;
    var percent = (0, _auxiliarFunctions.getPercentage)(value, totalValues);
    var valueWithPercent = resultFormatType === 'percent' ? value + ' (' + percent + '%)' : value;
    var valueToShow = typeof resultFormatType === 'function' ? resultFormatType(value) : valueWithPercent;
    var label = tooltip !== null && tooltip !== void 0 && tooltip.label ? tooltip.label + ': ' + name + '<br>' : '';
    var result = tooltip !== null && tooltip !== void 0 && tooltip.result ? marker + tooltip.result + ': ' + valueToShow : '';
    return tooltip ? label + result : marker + name + ': ' + valueToShow;
  };
  var formatDonutLabel = function formatDonutLabel(value) {
    return typeof resultFormatType === 'function' ? resultFormatType(value) : (0, _auxiliarFunctions.takeDonutChartComplement)(value, yComplement);
  };
  var series = [{
    type: 'pie',
    name: 'first',
    data: data,
    animation: true,
    radius: donutRadius,
    center: center || ['50%', '50%'],
    label: _objectSpread(_objectSpread({}, _commonStyles.COMMON_STYLE), {}, {
      distanceToLabelLine: 0,
      position: legendPosition || 'outside',
      color: labelFontColor || neutral[200],
      formatter: function formatter(item) {
        return yComplement || resultFormatType ? formatDonutLabel(item.data.value).toString() : String(item.data.value);
      }
    }),
    labelLine: {
      length: 5,
      length2: 5
    },
    itemStyle: {
      borderColor: neutral[50]
    },
    emphasis: {
      scale: true,
      scaleSize: 2
    }
  }];
  var myTool = (toolboxTooltip === null || toolboxTooltip === void 0 ? void 0 : toolboxTooltip.saveAsImageWithTitle) && {
    myTool: (0, _auxiliarFunctions.getSaveAsImageWithTitle)((_toolboxTooltip$saveA = toolboxTooltip.saveAsImageWithTitle.title) !== null && _toolboxTooltip$saveA !== void 0 ? _toolboxTooltip$saveA : '', handleShowTitle, title)
  };
  var toolbox = toolboxTooltip && _objectSpread(_objectSpread({}, _commonStyles.TOOLBOX_DEFAULT_PROPS), {}, {
    feature: _objectSpread(_objectSpread({}, myTool), {}, {
      saveAsImage: toolboxTooltip.saveAsImage && (0, _auxiliarFunctions.getSaveAsImage)((_toolboxTooltip$saveA2 = toolboxTooltip.saveAsImage.title) !== null && _toolboxTooltip$saveA2 !== void 0 ? _toolboxTooltip$saveA2 : '', title),
      dataView: toolboxTooltip.dataView && (0, _auxiliarFunctions.getDataView)((_toolboxTooltip$dataV = toolboxTooltip.dataView.title) !== null && _toolboxTooltip$dataV !== void 0 ? _toolboxTooltip$dataV : '')
    })
  });
  var options = function options() {
    return {
      grid: grid,
      color: colors,
      series: series,
      title: {
        top: 'middle',
        left: 'center',
        text: donutCenterValue || (0, _auxiliarFunctions.thousandSeparator)(totalValues),
        textStyle: _objectSpread(_objectSpread({}, _commonStyles.TITLE_STYLE), {}, {
          fontSize: centerPieValueFontSize || 24
        })
      },
      itemStyle: {
        borderColor: pieceBorderColor || neutral[50]
      },
      legend: {
        top: 280,
        data: dataLegend,
        type: legendType || 'plain',
        selectedMode: selectedMode || false,
        itemGap: legendType === 'scroll' ? 40 : 10,
        textStyle: _objectSpread({}, _commonStyles.COMMON_STYLE)
      },
      tooltip: _objectSpread({
        trigger: 'item',
        formatter: formatTooltip
      }, _commonStyles.TOOLTIP_DEFAULT_PROPS),
      toolbox: _objectSpread(_objectSpread({}, toolbox), {}, {
        tooltip: _objectSpread(_objectSpread({
          trigger: 'none'
        }, _commonStyles.TOOLTIP_DEFAULT_PROPS), {}, {
          formatter: function formatter(param) {
            return "<div>".concat(param.title, "</div>");
          }
        })
      })
    };
  };
  return /*#__PURE__*/_react["default"].createElement(_commonStyles.ChartWrapper, null, showTitle && /*#__PURE__*/_react["default"].createElement(_commonStyles.ChartTitle, null, title), /*#__PURE__*/_react["default"].createElement(_core2["default"], {
    echarts: echarts,
    option: options(),
    style: {
      width: 'auto',
      minWidth: '100%'
    },
    opts: {
      renderer: 'canvas',
      width: width !== null && width !== void 0 ? width : 'auto'
    }
  }));
};
var _default = exports["default"] = DonutChart;