import React from 'react';
import type { IDefaultChartProps, GaugeData } from '../types';
export interface IProps extends Omit<IDefaultChartProps, 'data'> {
    data: GaugeData[];
    legendValue?: number;
    axisLineWidth?: number;
    titleFontSize?: number;
    detailFontSize?: number;
    height?: number | string;
    colorLine?: [number, string][];
    axisLabel?: {
        limit: number;
        label: string;
    }[];
    legendData?: {
        icon: JSX.Element;
        legend: number;
    }[];
}
declare const GaugeChart: (props: IProps) => React.JSX.Element;
export default GaugeChart;
