"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");
var _typeof = require("@babel/runtime/helpers/typeof");
Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;
var _defineProperty2 = _interopRequireDefault(require("@babel/runtime/helpers/defineProperty"));
var _react = _interopRequireDefault(require("react"));
var _charts = require("echarts/charts");
var _components = require("echarts/components");
var echarts = _interopRequireWildcard(require("echarts/core"));
var _renderers = require("echarts/renderers");
var _core2 = _interopRequireDefault(require("echarts-for-react/lib/core"));
var _auxiliarFunctions = require("../../lib/auxiliarFunctions");
var _commonStyles = require("../../commonStyles");
var _theme = require("flipper-ui/theme");
function _interopRequireWildcard(e, t) { if ("function" == typeof WeakMap) var r = new WeakMap(), n = new WeakMap(); return (_interopRequireWildcard = function _interopRequireWildcard(e, t) { if (!t && e && e.__esModule) return e; var o, i, f = { __proto__: null, "default": e }; if (null === e || "object" != _typeof(e) && "function" != typeof e) return f; if (o = t ? n : r) { if (o.has(e)) return o.get(e); o.set(e, f); } for (var _t in e) "default" !== _t && {}.hasOwnProperty.call(e, _t) && ((i = (o = Object.defineProperty) && Object.getOwnPropertyDescriptor(e, _t)) && (i.get || i.set) ? o(f, _t, i) : f[_t] = e[_t]); return f; })(e, t); }
function ownKeys(e, r) { var t = Object.keys(e); if (Object.getOwnPropertySymbols) { var o = Object.getOwnPropertySymbols(e); r && (o = o.filter(function (r) { return Object.getOwnPropertyDescriptor(e, r).enumerable; })), t.push.apply(t, o); } return t; }
function _objectSpread(e) { for (var r = 1; r < arguments.length; r++) { var t = null != arguments[r] ? arguments[r] : {}; r % 2 ? ownKeys(Object(t), !0).forEach(function (r) { (0, _defineProperty2["default"])(e, r, t[r]); }) : Object.getOwnPropertyDescriptors ? Object.defineProperties(e, Object.getOwnPropertyDescriptors(t)) : ownKeys(Object(t)).forEach(function (r) { Object.defineProperty(e, r, Object.getOwnPropertyDescriptor(t, r)); }); } return e; }
var _theme$colors = _theme.theme.colors,
  amber = _theme$colors.amber,
  green = _theme$colors.green,
  red = _theme$colors.red,
  orange = _theme$colors.orange,
  gray = _theme$colors.gray;
echarts.use([_components.GridComponent, _components.TitleComponent, _renderers.CanvasRenderer, _components.LegendComponent, _components.TooltipComponent, _components.ToolboxComponent, _charts.GaugeChart]);
var GaugeChart = function GaugeChart(props) {
  var _toolboxTooltip$saveA;
  var data = props.data,
    height = props.height,
    tooltip = props.tooltip,
    axisLabel = props.axisLabel,
    colorLine = props.colorLine,
    legendData = props.legendData,
    legendValue = props.legendValue,
    axisLineWidth = props.axisLineWidth,
    titleFontSize = props.titleFontSize,
    toolboxTooltip = props.toolboxTooltip,
    detailFontSize = props.detailFontSize;
  var getColor = function getColor(value) {
    return value <= (legendValue !== null && legendValue !== void 0 ? legendValue : 75) ? red[500] : green[300];
  };
  var formatTooltip = function formatTooltip() {
    return tooltip ? "".concat(tooltip.label, ": ").concat(Number(tooltip.labelComplement) * 100, " %") : '';
  };
  var formatAxisLabel = function formatAxisLabel(value) {
    var match = axisLabel === null || axisLabel === void 0 ? void 0 : axisLabel.find(function (item) {
      return item.limit === value;
    });
    return match ? match.label : '';
  };
  var series = [{
    type: 'gauge',
    data: data,
    min: 0,
    max: 1,
    endAngle: 0,
    startAngle: 180,
    splitNumber: 8,
    radius: '90%',
    center: ['50%', '70%'],
    title: {
      fontSize: titleFontSize !== null && titleFontSize !== void 0 ? titleFontSize : 30,
      color: gray[800],
      offsetCenter: [0, '20%']
    },
    detail: {
      fontSize: detailFontSize !== null && detailFontSize !== void 0 ? detailFontSize : 24,
      color: gray[900],
      valueAnimation: true,
      offsetCenter: [0, '40%'],
      formatter: function formatter(value) {
        return Math.round(value * 100) + ' %';
      }
    },
    splitLine: {
      length: 0
    },
    axisTick: {
      length: 0
    },
    axisLabel: {
      fontSize: 16,
      distance: -40,
      color: gray[800],
      rotate: 'tangential',
      formatter: formatAxisLabel
    },
    axisLine: {
      lineStyle: {
        width: axisLineWidth !== null && axisLineWidth !== void 0 ? axisLineWidth : 75,
        color: colorLine !== null && colorLine !== void 0 ? colorLine : [[0.25, red[500]], [0.5, orange[600]], [0.75, amber[500]], [1, green[300]]]
      }
    },
    pointer: {
      width: 20,
      length: '95%',
      offsetCenter: [0, '-5%'],
      icon: 'path://M12.8,-0.7l12,-40.1H0.7L12.8,-0.7z',
      itemStyle: {
        color: gray[900]
      }
    }
  }];
  var toolbox = toolboxTooltip && {
    top: '10%',
    right: '15%',
    showTitle: false,
    feature: {
      saveAsImage: toolboxTooltip.saveAsImage && (0, _auxiliarFunctions.getSaveAsImage)((_toolboxTooltip$saveA = toolboxTooltip.saveAsImage.title) !== null && _toolboxTooltip$saveA !== void 0 ? _toolboxTooltip$saveA : '')
    }
  };
  var options = function options() {
    return {
      series: series,
      tooltip: _objectSpread({
        trigger: 'item',
        formatter: formatTooltip
      }, _commonStyles.TOOLTIP_DEFAULT_PROPS),
      toolbox: _objectSpread(_objectSpread({}, toolbox), {}, {
        tooltip: _objectSpread(_objectSpread({
          trigger: 'none'
        }, _commonStyles.TOOLTIP_DEFAULT_PROPS), {}, {
          formatter: function formatter(param) {
            return "<div>".concat(param.title, "</div>");
          }
        })
      })
    };
  };
  return /*#__PURE__*/_react["default"].createElement("div", null, /*#__PURE__*/_react["default"].createElement(_core2["default"], {
    echarts: echarts,
    option: options(),
    opts: {
      renderer: 'canvas',
      width: 'auto'
    },
    style: {
      width: '99.9%',
      height: height || 400
    }
  }), /*#__PURE__*/_react["default"].createElement(_commonStyles.GaugeLegendContainer, null, legendData === null || legendData === void 0 ? void 0 : legendData.map(function (it, i) {
    return /*#__PURE__*/_react["default"].createElement(_commonStyles.GaugeLegendContent, {
      key: i
    }, /*#__PURE__*/_react["default"].createElement(_commonStyles.GaugeIconContainer, null, it.icon), /*#__PURE__*/_react["default"].createElement(_commonStyles.GaugeCircle, {
      color: getColor(it.legend)
    }), /*#__PURE__*/_react["default"].createElement(_commonStyles.GaugeLegend, null, it.legend + ' %'));
  })));
};
var _default = exports["default"] = GaugeChart;