"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");
var _typeof = require("@babel/runtime/helpers/typeof");
Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;
var _regenerator = _interopRequireDefault(require("@babel/runtime/regenerator"));
var _toConsumableArray2 = _interopRequireDefault(require("@babel/runtime/helpers/toConsumableArray"));
var _defineProperty2 = _interopRequireDefault(require("@babel/runtime/helpers/defineProperty"));
var _asyncToGenerator2 = _interopRequireDefault(require("@babel/runtime/helpers/asyncToGenerator"));
var _slicedToArray2 = _interopRequireDefault(require("@babel/runtime/helpers/slicedToArray"));
var _react = _interopRequireWildcard(require("react"));
var _charts = require("echarts/charts");
var _components = require("echarts/components");
var echarts = _interopRequireWildcard(require("echarts/core"));
var _renderers = require("echarts/renderers");
var _core2 = _interopRequireDefault(require("echarts-for-react/lib/core"));
var _ramda = require("ramda");
var _auxiliarFunctions = require("../../lib/auxiliarFunctions");
var _commonStyles = require("../../commonStyles");
var _theme = require("flipper-ui/theme");
function _interopRequireWildcard(e, t) { if ("function" == typeof WeakMap) var r = new WeakMap(), n = new WeakMap(); return (_interopRequireWildcard = function _interopRequireWildcard(e, t) { if (!t && e && e.__esModule) return e; var o, i, f = { __proto__: null, "default": e }; if (null === e || "object" != _typeof(e) && "function" != typeof e) return f; if (o = t ? n : r) { if (o.has(e)) return o.get(e); o.set(e, f); } for (var _t in e) "default" !== _t && {}.hasOwnProperty.call(e, _t) && ((i = (o = Object.defineProperty) && Object.getOwnPropertyDescriptor(e, _t)) && (i.get || i.set) ? o(f, _t, i) : f[_t] = e[_t]); return f; })(e, t); }
function ownKeys(e, r) { var t = Object.keys(e); if (Object.getOwnPropertySymbols) { var o = Object.getOwnPropertySymbols(e); r && (o = o.filter(function (r) { return Object.getOwnPropertyDescriptor(e, r).enumerable; })), t.push.apply(t, o); } return t; }
function _objectSpread(e) { for (var r = 1; r < arguments.length; r++) { var t = null != arguments[r] ? arguments[r] : {}; r % 2 ? ownKeys(Object(t), !0).forEach(function (r) { (0, _defineProperty2["default"])(e, r, t[r]); }) : Object.getOwnPropertyDescriptors ? Object.defineProperties(e, Object.getOwnPropertyDescriptors(t)) : ownKeys(Object(t)).forEach(function (r) { Object.defineProperty(e, r, Object.getOwnPropertyDescriptor(t, r)); }); } return e; }
var gray = _theme.theme.colors.gray;
echarts.use([_components.GridComponent, _components.TitleComponent, _renderers.CanvasRenderer, _components.LegendComponent, _components.TooltipComponent, _components.ToolboxComponent, _charts.BarChart]);
var HorizontalBarChart = function HorizontalBarChart(props) {
  var _toolboxTooltip$saveA, _toolboxTooltip$saveA2, _toolboxTooltip$dataV;
  var data = props.data,
    grid = props.grid,
    width = props.width,
    color = props.color,
    xType = props.xType,
    title = props.title,
    tooltip = props.tooltip,
    xComplement = props.xComplement,
    rotateLabel = props.rotateLabel,
    labelWordSize = props.labelWordSize,
    showTickInfos = props.showTickInfos,
    boldTickLabel = props.boldTickLabel,
    titleFontSize = props.titleFontSize,
    toolboxTooltip = props.toolboxTooltip,
    marginLeftTitle = props.marginLeftTitle,
    marginRightToolbox = props.marginRightToolbox,
    onClickBar = props.onClickBar;
  var _useState = (0, _react.useState)(false),
    _useState2 = (0, _slicedToArray2["default"])(_useState, 2),
    showTitle = _useState2[0],
    setShowTitle = _useState2[1];
  var _useState3 = (0, _react.useState)([]),
    _useState4 = (0, _slicedToArray2["default"])(_useState3, 2),
    richData = _useState4[0],
    setRichData = _useState4[1];
  var clickEvent = {
    click: onClickBar !== null && onClickBar !== void 0 ? onClickBar : function () {}
  };
  (0, _react.useEffect)(function () {
    if (toolboxTooltip !== null && toolboxTooltip !== void 0 && toolboxTooltip.saveAsImageWithTitle) {
      setShowTitle(false);
    } else {
      setShowTitle(true);
    }
  }, [toolboxTooltip]);
  (0, _react.useEffect)(function () {
    data.map(/*#__PURE__*/function () {
      var _ref = (0, _asyncToGenerator2["default"])(/*#__PURE__*/_regenerator["default"].mark(function _callee(item) {
        var rich;
        return _regenerator["default"].wrap(function _callee$(_context) {
          while (1) switch (_context.prev = _context.next) {
            case 0:
              if (item.image) {
                _context.next = 2;
                break;
              }
              return _context.abrupt("return", {});
            case 2:
              _context.t0 = _defineProperty2["default"];
              _context.t1 = {};
              _context.t2 = (0, _auxiliarFunctions.changeSpaceForUnderline)(item.label);
              _context.next = 7;
              return (0, _auxiliarFunctions.convertImageToBase64FromUrl)(item.image);
            case 7:
              _context.t3 = _context.sent;
              _context.t4 = {
                image: _context.t3
              };
              _context.t5 = {
                height: 35,
                backgroundColor: _context.t4
              };
              rich = (0, _context.t0)(_context.t1, _context.t2, _context.t5);
              if (!richData.find(function (itemRich) {
                return (0, _auxiliarFunctions.changeSpaceForUnderline)(item.label) in itemRich;
              })) {
                setRichData(function (state) {
                  return [].concat((0, _toConsumableArray2["default"])(state), [rich]);
                });
              }
            case 12:
            case "end":
              return _context.stop();
          }
        }, _callee);
      }));
      return function (_x) {
        return _ref.apply(this, arguments);
      };
    }());
  }, [richData]);
  var formatTooltip = function formatTooltip(chartValues) {
    var label = tooltip === null || tooltip === void 0 ? void 0 : tooltip.label;
    var result = tooltip === null || tooltip === void 0 ? void 0 : tooltip.result;
    var _chartValues$ = chartValues[1],
      name = _chartValues$.name,
      value = _chartValues$.value;
    var dataValue = xType === 'time' ? (0, _auxiliarFunctions.timeConvert)(Number(value)).toString() + 'h' : (0, _auxiliarFunctions.takeLabelComplement)(Number(value), xComplement !== null && xComplement !== void 0 ? xComplement : '').toString();
    return "".concat(label, ": ").concat(name, " <br>") + "".concat(result, ": ").concat(dataValue, " <br>");
  };
  var formatLabel = function formatLabel(chartValues) {
    var value = chartValues.value;
    return xType === 'time' ? (0, _auxiliarFunctions.timeConvert)(Number(value)).toString() + 'h' : (0, _auxiliarFunctions.takeLabelComplement)(Number(value), xComplement !== null && xComplement !== void 0 ? xComplement : '').toString();
  };
  var formatterLabel = function formatterLabel(item) {
    var _ref2;
    return xType === 'time' ? (0, _auxiliarFunctions.timeConvert)(Number(item)).toString() + 'h' : (_ref2 = xComplement && (item + xComplement).toString()) !== null && _ref2 !== void 0 ? _ref2 : '';
  };
  var handleShowTitle = function handleShowTitle(show) {
    setShowTitle(show);
  };
  var yData = (0, _ramda.reverse)(data.map(function (item) {
    return item.label;
  }));
  var domain = {
    min: 0,
    max: Math.max.apply(Math, (0, _toConsumableArray2["default"])(data.map(function (item) {
      return item.result;
    })))
  };
  var backgroundBar = data.map(function () {
    return xComplement === '%' ? 100 : (0, _auxiliarFunctions.getDomain)(domain);
  });
  var xData = (0, _ramda.reverse)(data.map(function (item) {
    var results = data.map(function (item) {
      return item.result;
    });
    var maxValue = Math.max.apply(Math, (0, _toConsumableArray2["default"])(results));
    var label = {};
    if (item.result <= (!showTickInfos ? 50 : 15)) {
      label = {
        position: 'right',
        distance: 1
      };
    }
    if (maxValue !== item.result && xType === 'time') {
      var mainPercentage = item.result * 100 / maxValue;
      var _label = mainPercentage < 15 ? {
        position: 'right',
        distance: 1
      } : {};
      return {
        value: item.result,
        label: _label,
        itemStyle: item.style,
        itemId: item.itemId
      };
    }
    return {
      value: item.result,
      label: label,
      itemStyle: item.style,
      itemId: item.itemId
    };
  }));
  var series = [{
    type: 'bar',
    silent: true,
    xAxisIndex: 0,
    barGap: '-100%',
    barWidth: '80%',
    animation: false,
    data: backgroundBar,
    barMaxWidth: !showTickInfos && 20,
    itemStyle: {
      color: gray[200],
      opacity: showTickInfos && 0.5,
      borderRadius: showTickInfos ? 0 : 10,
      borderColor: showTickInfos ? undefined : props.color
    }
  }, {
    type: 'bar',
    data: xData,
    xAxisIndex: 0,
    barWidth: '80%',
    barMaxWidth: !showTickInfos && 20,
    label: _objectSpread({
      show: true,
      formatter: formatLabel,
      position: 'insideRight',
      fontSize: showTickInfos ? 14 : 11
    }, _commonStyles.COMMON_STYLE),
    itemStyle: {
      color: color,
      borderRadius: showTickInfos ? 0 : 10
    }
  }];
  var myTool = (toolboxTooltip === null || toolboxTooltip === void 0 ? void 0 : toolboxTooltip.saveAsImageWithTitle) && {
    myTool: (0, _auxiliarFunctions.getSaveAsImageWithTitle)((_toolboxTooltip$saveA = toolboxTooltip.saveAsImageWithTitle.title) !== null && _toolboxTooltip$saveA !== void 0 ? _toolboxTooltip$saveA : '', handleShowTitle)
  };
  var toolbox = toolboxTooltip && {
    showTitle: false,
    right: marginRightToolbox || '8.7%',
    feature: _objectSpread(_objectSpread({}, myTool), {}, {
      saveAsImage: toolboxTooltip.saveAsImage && (0, _auxiliarFunctions.getSaveAsImage)((_toolboxTooltip$saveA2 = toolboxTooltip.saveAsImage.title) !== null && _toolboxTooltip$saveA2 !== void 0 ? _toolboxTooltip$saveA2 : ''),
      dataView: toolboxTooltip.dataView && (0, _auxiliarFunctions.getDataView)((_toolboxTooltip$dataV = toolboxTooltip.dataView.title) !== null && _toolboxTooltip$dataV !== void 0 ? _toolboxTooltip$dataV : '')
    })
  };
  var options = function options() {
    return {
      series: series,
      grid: _objectSpread({
        containLabel: true
      }, grid),
      title: {
        text: title,
        show: showTitle,
        left: marginLeftTitle || '5.9%',
        textStyle: _objectSpread(_objectSpread({}, _commonStyles.TITLE_STYLE), {}, {
          fontSize: titleFontSize || 16
        })
      },
      xAxis: {
        type: 'value',
        axisLabel: _objectSpread(_objectSpread({}, _commonStyles.COMMON_STYLE), {}, {
          rotate: rotateLabel,
          formatter: formatterLabel,
          show: showTickInfos || false
        }),
        axisTick: {
          show: showTickInfos || false
        },
        axisLine: {
          show: showTickInfos || false
        },
        splitLine: {
          show: showTickInfos || false,
          lineStyle: _objectSpread({}, _commonStyles.AXIS_SPLIT_LINE)
        },
        max: xComplement === '%' ? 100 : (0, _auxiliarFunctions.getDomain)(domain)
      },
      yAxis: {
        type: 'category',
        data: yData,
        inverse: true,
        axisLabel: _objectSpread(_objectSpread({
          margin: 12
        }, _commonStyles.COMMON_STYLE), {}, {
          fontWeight: boldTickLabel ? 400 : '',
          rich: Object.assign.apply(Object, [{}].concat((0, _toConsumableArray2["default"])(richData))),
          formatter: function formatter(text) {
            return data.find(function (item) {
              return item.image;
            }) ? (0, _auxiliarFunctions.formatLabelWithImage)(text) : (0, _auxiliarFunctions.truncateLabel)(text, labelWordSize);
          }
        }),
        axisTick: {
          alignWithLabel: true,
          show: showTickInfos || false
        },
        axisLine: {
          show: showTickInfos || false
        },
        splitLine: {
          show: showTickInfos || false,
          lineStyle: _objectSpread({}, _commonStyles.AXIS_SPLIT_LINE)
        }
      },
      tooltip: tooltip && _objectSpread({
        trigger: 'axis',
        formatter: formatTooltip,
        axisPointer: {
          type: 'shadow',
          shadowStyle: {
            opacity: 0.5
          }
        }
      }, _commonStyles.TOOLTIP_DEFAULT_PROPS),
      toolbox: _objectSpread(_objectSpread({}, toolbox), {}, {
        tooltip: _objectSpread(_objectSpread({}, _commonStyles.TOOLTIP_DEFAULT_PROPS), {}, {
          formatter: function formatter(param) {
            return "<div>".concat(param.title, "</div>");
          }
        })
      })
    };
  };
  return /*#__PURE__*/_react["default"].createElement(_commonStyles.ChartContainer, null, /*#__PURE__*/_react["default"].createElement(_core2["default"], {
    echarts: echarts,
    option: options(),
    style: {
      width: '99.9%'
    },
    opts: {
      renderer: 'canvas',
      width: width !== null && width !== void 0 ? width : 'auto'
    },
    onEvents: clickEvent
  }));
};
var _default = exports["default"] = HorizontalBarChart;