"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");
var _typeof = require("@babel/runtime/helpers/typeof");
Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;
var _defineProperty2 = _interopRequireDefault(require("@babel/runtime/helpers/defineProperty"));
var _toConsumableArray2 = _interopRequireDefault(require("@babel/runtime/helpers/toConsumableArray"));
var _react = _interopRequireWildcard(require("react"));
var _charts = require("echarts/charts");
var _components = require("echarts/components");
var echarts = _interopRequireWildcard(require("echarts/core"));
var _renderers = require("echarts/renderers");
var _core2 = _interopRequireDefault(require("echarts-for-react/lib/core"));
var _auxiliarFunctions = require("../../lib/auxiliarFunctions");
var _commonStyles = require("../../commonStyles");
var _theme = require("flipper-ui/theme");
function _interopRequireWildcard(e, t) { if ("function" == typeof WeakMap) var r = new WeakMap(), n = new WeakMap(); return (_interopRequireWildcard = function _interopRequireWildcard(e, t) { if (!t && e && e.__esModule) return e; var o, i, f = { __proto__: null, "default": e }; if (null === e || "object" != _typeof(e) && "function" != typeof e) return f; if (o = t ? n : r) { if (o.has(e)) return o.get(e); o.set(e, f); } for (var _t in e) "default" !== _t && {}.hasOwnProperty.call(e, _t) && ((i = (o = Object.defineProperty) && Object.getOwnPropertyDescriptor(e, _t)) && (i.get || i.set) ? o(f, _t, i) : f[_t] = e[_t]); return f; })(e, t); }
function ownKeys(e, r) { var t = Object.keys(e); if (Object.getOwnPropertySymbols) { var o = Object.getOwnPropertySymbols(e); r && (o = o.filter(function (r) { return Object.getOwnPropertyDescriptor(e, r).enumerable; })), t.push.apply(t, o); } return t; }
function _objectSpread(e) { for (var r = 1; r < arguments.length; r++) { var t = null != arguments[r] ? arguments[r] : {}; r % 2 ? ownKeys(Object(t), !0).forEach(function (r) { (0, _defineProperty2["default"])(e, r, t[r]); }) : Object.getOwnPropertyDescriptors ? Object.defineProperties(e, Object.getOwnPropertyDescriptors(t)) : ownKeys(Object(t)).forEach(function (r) { Object.defineProperty(e, r, Object.getOwnPropertyDescriptor(t, r)); }); } return e; }
var _theme$colors = _theme.theme.colors,
  gray = _theme$colors.gray,
  neutral = _theme$colors.neutral;
echarts.use([_components.GridComponent, _components.TitleComponent, _renderers.CanvasRenderer, _components.LegendComponent, _components.TooltipComponent, _components.ToolboxComponent, _charts.BarChart, _charts.LineChart, _components.DataZoomInsideComponent, _components.DataZoomSliderComponent]);
var MultipurposeChart = function MultipurposeChart(props) {
  var xData = props.xData,
    xType = props.xType,
    width = props.width,
    yType = props.yType,
    series = props.series,
    dateFormat = props.dateFormat,
    rangeSelector = props.rangeSelector,
    yComplement = props.yComplement;
  var isStacked = (0, _react.useRef)(false);
  var actualGraph = (0, _react.useRef)('bar');
  var ref = (0, _react.useRef)(null);
  var isDarkColor = function isDarkColor(color) {
    var c = color.substring(1);
    var rgb = parseInt(c, 16);
    var r = rgb >> 16 & 0xff;
    var g = rgb >> 8 & 0xff;
    var b = rgb >> 0 & 0xff;
    var luma = 0.2126 * r + 0.7152 * g + 0.0722 * b;
    return luma < 40;
  };
  var getLabelOptions = function getLabelOptions(barColor) {
    var isDarkBarColor = isDarkColor(barColor);
    return {
      show: true,
      rotate: 90,
      fontSize: 16,
      align: 'left',
      position: 'insideBottom',
      verticalAlign: 'middle',
      color: isDarkBarColor ? neutral[50] : neutral[200],
      formatter: yComplement && yComplement('{c}') + '  {name|{a}}',
      rich: {
        name: {
          color: isDarkBarColor ? neutral[50] : neutral[200]
        }
      }
    };
  };
  var formatTooltip = function formatTooltip(lines) {
    var takeComplement = function takeComplement(value) {
      return yType === 'time' ? (0, _auxiliarFunctions.timeConvert)(Number(value)) + 'h' : (0, _auxiliarFunctions.takeLabelComplement)(Number(value), yComplement !== null && yComplement !== void 0 ? yComplement : '');
    };
    var linesTooltips = lines.map(function (line) {
      return line.seriesName + ': ' + takeComplement(Number(line.value)) + '<br>';
    });
    var tooltipTitle = xType === 'time' ? (0, _auxiliarFunctions.formatTime)(dateFormat === 'yyyy-MM' ? lines[0].name + '-02' : lines[0].name, dateFormat === 'yyyy-MM' ? 'MMM/yy' : 'dd MMM') : lines[0].name;
    return "".concat(tooltipTitle, " <br> ").concat(linesTooltips.join(' '));
  };
  var slider = rangeSelector ? [{
    type: 'slider',
    xAxisIndex: 0,
    filterMode: 'none'
  }] : [];
  var seriesData = (0, _toConsumableArray2["default"])(series.map(function (it) {
    var _it$color;
    return {
      type: 'bar',
      barGap: 0,
      data: it.data,
      name: it.name,
      emphasis: {
        focus: 'series'
      },
      label: getLabelOptions((_it$color = it.color) !== null && _it$color !== void 0 ? _it$color : '')
    };
  }));
  var options = {
    series: seriesData,
    dataZoom: [].concat(slider),
    color: (0, _toConsumableArray2["default"])(series.map(function (it) {
      return it.color;
    })),
    xAxis: {
      type: yType || 'category',
      data: xData,
      axisTick: {
        show: false
      },
      axisLabel: _objectSpread({}, _commonStyles.COMMON_STYLE)
    },
    yAxis: {
      type: xType || 'value',
      splitLine: {
        show: true,
        lineStyle: {
          type: 'solid',
          opacity: 0.3,
          color: gray[800]
        }
      },
      axisTick: {
        show: true
      },
      axisLabel: _objectSpread({}, _commonStyles.COMMON_STYLE),
      axisLine: {
        show: true,
        lineStyle: {
          color: neutral[200]
        }
      }
    },
    legend: {
      data: series.map(function (it) {
        return it.name;
      }),
      textStyle: _objectSpread({}, _commonStyles.COMMON_STYLE)
    },
    tooltip: _objectSpread({
      trigger: 'axis',
      formatter: formatTooltip,
      axisPointer: {
        type: 'shadow'
      }
    }, _commonStyles.TOOLTIP_DEFAULT_PROPS),
    toolbox: {
      show: true,
      top: 'center',
      left: 'right',
      orient: 'vertical',
      feature: {
        mark: {
          show: true
        },
        dataView: {
          show: true,
          readOnly: false,
          title: 'Visualização de dados',
          lang: ['Visualização de dados', 'Fechar', 'Atualizar']
        },
        magicType: {
          show: true,
          type: ['line', 'bar', 'stack'],
          title: {
            line: 'Gráfico de linha',
            bar: 'Gráfico de barras',
            stack: 'Estacar',
            title: 'Lado a lado'
          }
        },
        textStyle: {
          fontWeight: 400,
          fontFamily: 'Roboto, Helvetica, Arial, sans-serif'
        },
        saveAsImage: {
          show: true,
          title: 'Salvar como imagem'
        }
      }
    }
  };
  var onEvents = {
    magictypechanged: function magictypechanged(e) {
      var _ref$current, _ref$current2;
      var echartsInstance = (_ref$current = ref.current) === null || _ref$current === void 0 ? void 0 : _ref$current.getEchartsInstance();
      var actualOptions = echartsInstance === null || echartsInstance === void 0 ? void 0 : echartsInstance.getOption();
      if (e.currentType === 'stack') {
        isStacked.current = !isStacked.current;
      } else {
        actualGraph.current = e.currentType;
      }
      var newOptions = _objectSpread({}, actualOptions);
      newOptions.toolbox = options.toolbox;
      var isVertical = actualGraph.current === 'bar' && !isStacked.current;
      var isLine = actualGraph.current === 'line';
      var originalSeries = options.series;
      newOptions.series.forEach(function (it, i) {
        it.label.rotate = isVertical ? 90 : 0;
        it.label.align = isVertical ? 'left' : 'center';
        it.type = actualGraph.current;
        it.label.rich.name.color = isLine ? neutral[200] : originalSeries[i].label.rich.name.color;
        it.label.color = isLine ? neutral[200] : originalSeries[i].label.color;
      });
      (_ref$current2 = ref.current) === null || _ref$current2 === void 0 || _ref$current2.getEchartsInstance().setOption(newOptions);
    }
  };
  return /*#__PURE__*/_react["default"].createElement(_core2["default"], {
    ref: ref,
    echarts: echarts,
    option: options,
    style: {
      width: '99.9%'
    },
    opts: {
      renderer: 'canvas',
      width: width !== null && width !== void 0 ? width : 'auto'
    },
    onEvents: onEvents
  });
};
var _default = exports["default"] = MultipurposeChart;