"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");
var _typeof = require("@babel/runtime/helpers/typeof");
Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;
var _defineProperty2 = _interopRequireDefault(require("@babel/runtime/helpers/defineProperty"));
var _react = _interopRequireDefault(require("react"));
var _charts = require("echarts/charts");
var _components = require("echarts/components");
var echarts = _interopRequireWildcard(require("echarts/core"));
var _renderers = require("echarts/renderers");
var _core2 = _interopRequireDefault(require("echarts-for-react/lib/core"));
var _commonStyles = require("../../commonStyles");
var _theme = require("flipper-ui/theme");
function _interopRequireWildcard(e, t) { if ("function" == typeof WeakMap) var r = new WeakMap(), n = new WeakMap(); return (_interopRequireWildcard = function _interopRequireWildcard(e, t) { if (!t && e && e.__esModule) return e; var o, i, f = { __proto__: null, "default": e }; if (null === e || "object" != _typeof(e) && "function" != typeof e) return f; if (o = t ? n : r) { if (o.has(e)) return o.get(e); o.set(e, f); } for (var _t in e) "default" !== _t && {}.hasOwnProperty.call(e, _t) && ((i = (o = Object.defineProperty) && Object.getOwnPropertyDescriptor(e, _t)) && (i.get || i.set) ? o(f, _t, i) : f[_t] = e[_t]); return f; })(e, t); }
function ownKeys(e, r) { var t = Object.keys(e); if (Object.getOwnPropertySymbols) { var o = Object.getOwnPropertySymbols(e); r && (o = o.filter(function (r) { return Object.getOwnPropertyDescriptor(e, r).enumerable; })), t.push.apply(t, o); } return t; }
function _objectSpread(e) { for (var r = 1; r < arguments.length; r++) { var t = null != arguments[r] ? arguments[r] : {}; r % 2 ? ownKeys(Object(t), !0).forEach(function (r) { (0, _defineProperty2["default"])(e, r, t[r]); }) : Object.getOwnPropertyDescriptors ? Object.defineProperties(e, Object.getOwnPropertyDescriptors(t)) : ownKeys(Object(t)).forEach(function (r) { Object.defineProperty(e, r, Object.getOwnPropertyDescriptor(t, r)); }); } return e; }
var _theme$colors = _theme.theme.colors,
  gray = _theme$colors.gray,
  green = _theme$colors.green;
echarts.use([_components.GridComponent, _renderers.CanvasRenderer, _components.TooltipComponent, _charts.PictorialBarChart]);
var PictorialChart = function PictorialChart(props) {
  var data = props.data,
    color = props.color,
    grid = props.grid;
  var formatTooltip = function formatTooltip() {
    var _props$tooltip, _props$tooltip2, _props$tooltip3;
    return "".concat((_props$tooltip = props.tooltip) === null || _props$tooltip === void 0 ? void 0 : _props$tooltip.label, ": ").concat((_props$tooltip2 = props.tooltip) === null || _props$tooltip2 === void 0 ? void 0 : _props$tooltip2.labelComplement, " <br>") + ((_props$tooltip3 = props.tooltip) !== null && _props$tooltip3 !== void 0 && _props$tooltip3.result ? "".concat(props.tooltip.result, ": ").concat(props.tooltip.resultComplement) : '');
  };
  var options = function options() {
    return {
      series: [{
        type: 'pictorialBar',
        name: 'full',
        silent: true,
        symbolClip: true,
        animationDuration: 0,
        symbolBoundingData: 100,
        itemStyle: {
          color: gray[300]
        },
        data: [{
          value: 100,
          symbol: data[0].symbol
        }]
      }, {
        type: 'pictorialBar',
        name: 'empty',
        data: data,
        symbolClip: true,
        animationDuration: 100,
        symbolBoundingData: 100,
        itemStyle: {
          color: color || green[500]
        }
      }],
      xAxis: {
        data: ['a'],
        axisTick: {
          show: false
        },
        axisLine: {
          show: false
        },
        axisLabel: {
          show: false
        },
        splitLine: {
          show: false
        }
      },
      yAxis: {
        max: 100,
        axisTick: {
          show: false
        },
        axisLine: {
          show: false
        },
        axisLabel: {
          show: false
        },
        splitLine: {
          show: false
        }
      },
      grid: _objectSpread(_objectSpread({}, grid), {}, {
        top: 'center',
        show: false
      }),
      tooltip: _objectSpread({
        trigger: 'item',
        formatter: formatTooltip
      }, _commonStyles.TOOLTIP_DEFAULT_PROPS)
    };
  };
  return /*#__PURE__*/_react["default"].createElement(_core2["default"], {
    lazyUpdate: true,
    echarts: echarts,
    option: options(),
    opts: {
      renderer: 'canvas',
      width: 'auto'
    },
    style: {
      width: '99.9%',
      height: props.height || 500
    }
  });
};
var _default = exports["default"] = PictorialChart;