import React from 'react';
import type { PieChartData, IDefaultChartProps } from '../types';
export interface IPieProps extends Omit<IDefaultChartProps, 'data'> {
    radius?: string;
    colors?: string[];
    data: PieChartData[];
    noAnimation?: boolean;
    tooltipTitle?: string;
    labelFontColor?: string;
    pieceBorderColor?: string;
    legendType?: 'scroll' | 'plain';
    legendPosition?: 'inside' | 'outside';
    center?: [number, string] | [string, string] | string | number;
    resultFormatType?: 'percent' | ((value: string | number) => string);
}
declare const PieChart: (props: IPieProps) => React.JSX.Element;
export default PieChart;
