"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");
var _typeof = require("@babel/runtime/helpers/typeof");
Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;
var _defineProperty2 = _interopRequireDefault(require("@babel/runtime/helpers/defineProperty"));
var _slicedToArray2 = _interopRequireDefault(require("@babel/runtime/helpers/slicedToArray"));
var _react = _interopRequireWildcard(require("react"));
var _charts = require("echarts/charts");
var _components = require("echarts/components");
var echarts = _interopRequireWildcard(require("echarts/core"));
var _renderers = require("echarts/renderers");
var _core2 = _interopRequireDefault(require("echarts-for-react/lib/core"));
var _auxiliarFunctions = require("../../lib/auxiliarFunctions");
var _commonStyles = require("../../commonStyles");
var _theme = require("flipper-ui/theme");
function _interopRequireWildcard(e, t) { if ("function" == typeof WeakMap) var r = new WeakMap(), n = new WeakMap(); return (_interopRequireWildcard = function _interopRequireWildcard(e, t) { if (!t && e && e.__esModule) return e; var o, i, f = { __proto__: null, "default": e }; if (null === e || "object" != _typeof(e) && "function" != typeof e) return f; if (o = t ? n : r) { if (o.has(e)) return o.get(e); o.set(e, f); } for (var _t in e) "default" !== _t && {}.hasOwnProperty.call(e, _t) && ((i = (o = Object.defineProperty) && Object.getOwnPropertyDescriptor(e, _t)) && (i.get || i.set) ? o(f, _t, i) : f[_t] = e[_t]); return f; })(e, t); }
function ownKeys(e, r) { var t = Object.keys(e); if (Object.getOwnPropertySymbols) { var o = Object.getOwnPropertySymbols(e); r && (o = o.filter(function (r) { return Object.getOwnPropertyDescriptor(e, r).enumerable; })), t.push.apply(t, o); } return t; }
function _objectSpread(e) { for (var r = 1; r < arguments.length; r++) { var t = null != arguments[r] ? arguments[r] : {}; r % 2 ? ownKeys(Object(t), !0).forEach(function (r) { (0, _defineProperty2["default"])(e, r, t[r]); }) : Object.getOwnPropertyDescriptors ? Object.defineProperties(e, Object.getOwnPropertyDescriptors(t)) : ownKeys(Object(t)).forEach(function (r) { Object.defineProperty(e, r, Object.getOwnPropertyDescriptor(t, r)); }); } return e; }
var neutral = _theme.theme.colors.neutral;
echarts.use([_components.GridComponent, _components.TitleComponent, _renderers.CanvasRenderer, _components.LegendComponent, _components.TooltipComponent, _components.ToolboxComponent, _charts.PieChart]);
var PieChart = function PieChart(props) {
  var _toolboxTooltip$saveA, _toolboxTooltip$saveA2, _toolboxTooltip$dataV;
  var data = props.data,
    grid = props.grid,
    width = props.width,
    title = props.title,
    center = props.center,
    radius = props.radius,
    colors = props.colors,
    legendType = props.legendType,
    noAnimation = props.noAnimation,
    tooltipTitle = props.tooltipTitle,
    labelFontColor = props.labelFontColor,
    legendPosition = props.legendPosition,
    toolboxTooltip = props.toolboxTooltip,
    resultFormatType = props.resultFormatType,
    pieceBorderColor = props.pieceBorderColor;
  var dataLegend = data.map(function (item) {
    return item.name;
  });
  var totalValues = data.reduce(function (acc, item) {
    return acc + item.value;
  }, 0);
  var _useState = (0, _react.useState)(false),
    _useState2 = (0, _slicedToArray2["default"])(_useState, 2),
    showTitle = _useState2[0],
    setShowTitle = _useState2[1];
  (0, _react.useEffect)(function () {
    if (toolboxTooltip !== null && toolboxTooltip !== void 0 && toolboxTooltip.saveAsImageWithTitle) {
      setShowTitle(false);
    } else {
      setShowTitle(true);
    }
  }, [toolboxTooltip]);
  var handleShowTitle = function handleShowTitle(show) {
    setShowTitle(show);
  };
  var formatTooltip = function formatTooltip(_ref) {
    var name = _ref.name,
      value = _ref.value,
      marker = _ref.marker;
    var percent = (0, _auxiliarFunctions.getPercentage)(value, totalValues);
    var title = tooltipTitle ? tooltipTitle + '<br>' : '';
    var valuePrint = typeof resultFormatType === 'function' ? resultFormatType(value) : value;
    return title + marker + name + ': ' + valuePrint + ' ' + (resultFormatType === 'percent' ? '(' + percent + '%)' : '');
  };
  var formatPieLabel = function formatPieLabel(_ref2) {
    var data = _ref2.data;
    return data.value === 0 && legendPosition === 'inside' ? '' : (0, _auxiliarFunctions.takeLabelComplement)(data.value, resultFormatType !== null && resultFormatType !== void 0 ? resultFormatType : '', 'pie').toString();
  };
  var series = [{
    type: 'pie',
    data: data,
    animation: !noAnimation,
    stillShowZeroSum: false,
    radius: radius || '50%',
    center: center || ['50%', '50%'],
    label: _objectSpread(_objectSpread({
      show: true
    }, _commonStyles.COMMON_STYLE), {}, {
      formatter: formatPieLabel,
      position: legendPosition || 'outside',
      color: labelFontColor || neutral[50]
    }),
    itemStyle: {
      borderWidth: 1,
      borderColor: pieceBorderColor || neutral[50]
    },
    emphasis: {
      scale: true,
      scaleSize: 3
    }
  }];
  var myTool = (toolboxTooltip === null || toolboxTooltip === void 0 ? void 0 : toolboxTooltip.saveAsImageWithTitle) && {
    myTool: (0, _auxiliarFunctions.getSaveAsImageWithTitle)((_toolboxTooltip$saveA = toolboxTooltip.saveAsImageWithTitle.title) !== null && _toolboxTooltip$saveA !== void 0 ? _toolboxTooltip$saveA : '', handleShowTitle)
  };
  var toolbox = toolboxTooltip && _objectSpread(_objectSpread({}, _commonStyles.TOOLBOX_DEFAULT_PROPS), {}, {
    feature: _objectSpread(_objectSpread({}, myTool), {}, {
      saveAsImage: toolboxTooltip.saveAsImage && (0, _auxiliarFunctions.getSaveAsImage)((_toolboxTooltip$saveA2 = toolboxTooltip.saveAsImage.title) !== null && _toolboxTooltip$saveA2 !== void 0 ? _toolboxTooltip$saveA2 : ''),
      dataView: toolboxTooltip.dataView && (0, _auxiliarFunctions.getDataView)((_toolboxTooltip$dataV = toolboxTooltip.dataView.title) !== null && _toolboxTooltip$dataV !== void 0 ? _toolboxTooltip$dataV : '')
    })
  });
  var options = function options() {
    return {
      grid: grid,
      color: colors,
      series: series,
      title: {
        text: title,
        show: showTitle,
        textStyle: _objectSpread({}, _commonStyles.TITLE_STYLE)
      },
      legend: {
        top: 270,
        data: dataLegend,
        type: legendType || 'plain',
        itemGap: legendType === 'scroll' ? 60 : 10,
        textStyle: _objectSpread({}, _commonStyles.COMMON_STYLE)
      },
      tooltip: _objectSpread({
        trigger: 'item',
        formatter: formatTooltip
      }, _commonStyles.TOOLTIP_DEFAULT_PROPS),
      toolbox: _objectSpread(_objectSpread({}, toolbox), {}, {
        tooltip: _objectSpread(_objectSpread({
          trigger: 'none'
        }, _commonStyles.TOOLTIP_DEFAULT_PROPS), {}, {
          formatter: function formatter(param) {
            return "<div>".concat(param.title, "</div>");
          }
        })
      })
    };
  };
  return /*#__PURE__*/_react["default"].createElement(_core2["default"], {
    echarts: echarts,
    option: options(),
    style: {
      width: '99.9%'
    },
    opts: {
      renderer: 'canvas',
      width: width !== null && width !== void 0 ? width : 'auto'
    }
  });
};
var _default = exports["default"] = PieChart;