import React from 'react';
import type { IDefaultChartProps, ToolboxEntryProps, WidthProps } from '../types';
export interface ChartData {
    categories: string[];
    seriesData: SeriesData[];
}
export interface SeriesData {
    name: string;
    data: number[];
    color?: string;
    label?: string;
    image?: string;
    itemStyle?: object;
    labelPosition?: 'inside' | 'top' | 'bottom' | 'left' | 'right' | 'insideLeft' | 'insideRight' | 'insideTop' | 'insideBottom' | 'insideTopLeft' | 'insideBottomLeft' | 'insideTopRight' | 'insideBottomRight';
}
export interface IProps extends Omit<IDefaultChartProps, 'data'> {
    data: ChartData;
    showCSVDownload?: boolean;
    width?: WidthProps;
    color?: string;
    toolboxTooltip?: ToolboxEntryProps;
    legendType?: 'scroll' | 'none';
    showTickInfos?: boolean;
    xComplement?: string;
    boldTickLabel?: boolean;
    onClickBar?(itemProps?: Record<string, unknown>, itemFunctions?: Record<string, unknown>): void;
}
declare const PyramidBarChart: (props: IProps) => React.JSX.Element;
export default PyramidBarChart;
