import React from 'react';
import type { IDefaultChartProps, ToolboxEntryProps, WidthProps } from '../types';
export interface SeriesData {
    value: number;
    name: string;
    itemStyle?: object;
    tooltipText?: string;
}
export interface IProps extends Omit<IDefaultChartProps, 'data'> {
    style?: object;
    data: SeriesData[];
    width?: WidthProps;
    toolboxTooltip?: ToolboxEntryProps;
    custom?: {
        gap?: string | number;
        top?: string | number;
        left?: string | number;
        width?: string | number;
        bottom?: string | number;
        minSize?: string | number;
        maxSize?: string | number;
    };
    labelPosition?: 'inside' | 'top' | 'left' | 'right' | 'bottom' | 'insideLeft' | 'insideRight' | 'insideTop' | 'insideBottom' | 'insideTopLeft' | 'insideBottomLeft' | 'insideTopRight' | 'insideBottomRight';
}
declare const PyramidChart: (props: IProps) => React.JSX.Element;
export default PyramidChart;
