"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");
var _typeof = require("@babel/runtime/helpers/typeof");
Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;
var _defineProperty2 = _interopRequireDefault(require("@babel/runtime/helpers/defineProperty"));
var _slicedToArray2 = _interopRequireDefault(require("@babel/runtime/helpers/slicedToArray"));
var _react = _interopRequireWildcard(require("react"));
var _charts = require("echarts/charts");
var _components = require("echarts/components");
var echarts = _interopRequireWildcard(require("echarts/core"));
var _renderers = require("echarts/renderers");
var _core2 = _interopRequireDefault(require("echarts-for-react/lib/core"));
var _auxiliarFunctions = require("../../lib/auxiliarFunctions");
var _commonStyles = require("../../commonStyles");
function _interopRequireWildcard(e, t) { if ("function" == typeof WeakMap) var r = new WeakMap(), n = new WeakMap(); return (_interopRequireWildcard = function _interopRequireWildcard(e, t) { if (!t && e && e.__esModule) return e; var o, i, f = { __proto__: null, "default": e }; if (null === e || "object" != _typeof(e) && "function" != typeof e) return f; if (o = t ? n : r) { if (o.has(e)) return o.get(e); o.set(e, f); } for (var _t in e) "default" !== _t && {}.hasOwnProperty.call(e, _t) && ((i = (o = Object.defineProperty) && Object.getOwnPropertyDescriptor(e, _t)) && (i.get || i.set) ? o(f, _t, i) : f[_t] = e[_t]); return f; })(e, t); }
function ownKeys(e, r) { var t = Object.keys(e); if (Object.getOwnPropertySymbols) { var o = Object.getOwnPropertySymbols(e); r && (o = o.filter(function (r) { return Object.getOwnPropertyDescriptor(e, r).enumerable; })), t.push.apply(t, o); } return t; }
function _objectSpread(e) { for (var r = 1; r < arguments.length; r++) { var t = null != arguments[r] ? arguments[r] : {}; r % 2 ? ownKeys(Object(t), !0).forEach(function (r) { (0, _defineProperty2["default"])(e, r, t[r]); }) : Object.getOwnPropertyDescriptors ? Object.defineProperties(e, Object.getOwnPropertyDescriptors(t)) : ownKeys(Object(t)).forEach(function (r) { Object.defineProperty(e, r, Object.getOwnPropertyDescriptor(t, r)); }); } return e; }
echarts.use([_components.TitleComponent, _renderers.CanvasRenderer, _components.TooltipComponent, _components.ToolboxComponent, _charts.FunnelChart]);
var PyramidChart = function PyramidChart(props) {
  var _toolboxTooltip$saveA, _toolboxTooltip$saveA2, _toolboxTooltip$dataV;
  var data = props.data,
    style = props.style,
    title = props.title,
    custom = props.custom,
    titleFontSize = props.titleFontSize,
    labelPosition = props.labelPosition,
    toolboxTooltip = props.toolboxTooltip,
    marginRightToolbox = props.marginRightToolbox;
  var _useState = (0, _react.useState)(false),
    _useState2 = (0, _slicedToArray2["default"])(_useState, 2),
    showTitle = _useState2[0],
    setShowTitle = _useState2[1];
  (0, _react.useEffect)(function () {
    if (toolboxTooltip !== null && toolboxTooltip !== void 0 && toolboxTooltip.saveAsImageWithTitle) {
      setShowTitle(false);
    } else {
      setShowTitle(true);
    }
  }, [toolboxTooltip]);
  var handleShowTitle = function handleShowTitle(show) {
    setShowTitle(show);
  };
  var myTool = (toolboxTooltip === null || toolboxTooltip === void 0 ? void 0 : toolboxTooltip.saveAsImageWithTitle) && {
    myTool: (0, _auxiliarFunctions.getSaveAsImageWithTitle)((_toolboxTooltip$saveA = toolboxTooltip.saveAsImageWithTitle.title) !== null && _toolboxTooltip$saveA !== void 0 ? _toolboxTooltip$saveA : '', handleShowTitle)
  };
  var toolbox = toolboxTooltip && {
    showTitle: false,
    right: marginRightToolbox || '2%',
    feature: _objectSpread(_objectSpread({}, myTool), {}, {
      saveAsImage: toolboxTooltip.saveAsImage && (0, _auxiliarFunctions.getSaveAsImage)((_toolboxTooltip$saveA2 = toolboxTooltip.saveAsImage.title) !== null && _toolboxTooltip$saveA2 !== void 0 ? _toolboxTooltip$saveA2 : ''),
      dataView: toolboxTooltip.dataView && (0, _auxiliarFunctions.getDataView)((_toolboxTooltip$dataV = toolboxTooltip.dataView.title) !== null && _toolboxTooltip$dataV !== void 0 ? _toolboxTooltip$dataV : '')
    })
  };
  var series = [{
    type: 'funnel',
    sort: 'ascending',
    data: data.map(function (item) {
      return {
        name: item.name,
        value: item.value,
        itemStyle: item.itemStyle
      };
    }),
    label: {
      show: true,
      fontWeight: 600,
      position: labelPosition || 'inside'
    },
    gap: (custom === null || custom === void 0 ? void 0 : custom.gap) || 2,
    top: (custom === null || custom === void 0 ? void 0 : custom.top) || 20,
    left: (custom === null || custom === void 0 ? void 0 : custom.left) || '10%',
    bottom: (custom === null || custom === void 0 ? void 0 : custom.bottom) || 20,
    width: (custom === null || custom === void 0 ? void 0 : custom.width) || '80%',
    minSize: (custom === null || custom === void 0 ? void 0 : custom.minSize) || '0',
    maxSize: (custom === null || custom === void 0 ? void 0 : custom.maxSize) || '80%'
  }];
  var options = function options() {
    return {
      series: series,
      title: {
        left: '2%',
        text: title,
        show: showTitle,
        textStyle: _objectSpread(_objectSpread({}, _commonStyles.TITLE_STYLE), {}, {
          fontSize: titleFontSize || 16
        })
      },
      tooltip: _objectSpread(_objectSpread({
        trigger: 'item'
      }, _commonStyles.TOOLTIP_DEFAULT_PROPS), {}, {
        axisPointer: {
          type: 'shadow'
        },
        formatter: function formatter(params) {
          var dataItem = data.find(function (item) {
            return item.name === params.name;
          });
          return dataItem ? dataItem.tooltipText : params.name;
        }
      }),
      toolbox: _objectSpread(_objectSpread({}, toolbox), {}, {
        tooltip: _objectSpread(_objectSpread({}, _commonStyles.TOOLTIP_DEFAULT_PROPS), {}, {
          formatter: function formatter(param) {
            return "<div>".concat(param.title, "</div>");
          }
        })
      })
    };
  };
  return /*#__PURE__*/_react["default"].createElement(_core2["default"], {
    echarts: echarts,
    option: options(),
    style: style ? style : {
      width: '99.9%'
    },
    opts: {
      renderer: 'canvas',
      width: 'auto'
    }
  });
};
var _default = exports["default"] = PyramidChart;