"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");
var _typeof = require("@babel/runtime/helpers/typeof");
Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;
var _defineProperty2 = _interopRequireDefault(require("@babel/runtime/helpers/defineProperty"));
var _react = _interopRequireDefault(require("react"));
var _charts = require("echarts/charts");
var _components = require("echarts/components");
var echarts = _interopRequireWildcard(require("echarts/core"));
var _renderers = require("echarts/renderers");
var _core2 = _interopRequireDefault(require("echarts-for-react/lib/core"));
var _auxiliarFunctions = require("../../lib/auxiliarFunctions");
var _commonStyles = require("../../commonStyles");
var _theme = require("flipper-ui/theme");
function _interopRequireWildcard(e, t) { if ("function" == typeof WeakMap) var r = new WeakMap(), n = new WeakMap(); return (_interopRequireWildcard = function _interopRequireWildcard(e, t) { if (!t && e && e.__esModule) return e; var o, i, f = { __proto__: null, "default": e }; if (null === e || "object" != _typeof(e) && "function" != typeof e) return f; if (o = t ? n : r) { if (o.has(e)) return o.get(e); o.set(e, f); } for (var _t in e) "default" !== _t && {}.hasOwnProperty.call(e, _t) && ((i = (o = Object.defineProperty) && Object.getOwnPropertyDescriptor(e, _t)) && (i.get || i.set) ? o(f, _t, i) : f[_t] = e[_t]); return f; })(e, t); }
function ownKeys(e, r) { var t = Object.keys(e); if (Object.getOwnPropertySymbols) { var o = Object.getOwnPropertySymbols(e); r && (o = o.filter(function (r) { return Object.getOwnPropertyDescriptor(e, r).enumerable; })), t.push.apply(t, o); } return t; }
function _objectSpread(e) { for (var r = 1; r < arguments.length; r++) { var t = null != arguments[r] ? arguments[r] : {}; r % 2 ? ownKeys(Object(t), !0).forEach(function (r) { (0, _defineProperty2["default"])(e, r, t[r]); }) : Object.getOwnPropertyDescriptors ? Object.defineProperties(e, Object.getOwnPropertyDescriptors(t)) : ownKeys(Object(t)).forEach(function (r) { Object.defineProperty(e, r, Object.getOwnPropertyDescriptor(t, r)); }); } return e; }
var lightGreen = _theme.theme.colors.lightGreen;
echarts.use([_components.TitleComponent, _renderers.CanvasRenderer, _components.LegendComponent, _components.TooltipComponent, _charts.RadarChart]);
var RadarChart = function RadarChart(props) {
  var series = props.series,
    width = props.width,
    indicators = props.indicators,
    circular = props.circular,
    highlight = props.highlight,
    yComplement = props.yComplement;
  var takeComplement = function takeComplement(value) {
    return (0, _auxiliarFunctions.takeLabelComplement)(Number(value), yComplement !== null && yComplement !== void 0 ? yComplement : '');
  };
  var formatTooltip = function formatTooltip(lines) {
    var linesTooltips = lines.data.value.map(function (value, i) {
      return indicators[i].name + ': ' + takeComplement(Number(value)) + '<br>';
    });
    return "".concat(lines.name, " <br> ").concat(linesTooltips.join(' '));
  };
  var seriesData = [_objectSpread({
    type: 'radar',
    data: series.map(function (it) {
      return {
        name: it.name,
        value: it.data
      };
    })
  }, highlight && {
    emphasis: {
      areaStyle: {
        color: "".concat(lightGreen[300], "90")
      }
    }
  })];
  var options = function options() {
    return {
      series: seriesData,
      color: series.map(function (it) {
        return it.color;
      }),
      radar: {
        shape: circular ? 'circle' : 'polygon',
        indicator: indicators.map(function (it) {
          return {
            max: it.max,
            name: it.name
          };
        })
      },
      legend: {
        margin: 0,
        padding: 0,
        data: series.map(function (it) {
          return it.name;
        }),
        textStyle: _objectSpread({}, _commonStyles.COMMON_STYLE)
      },
      tooltip: _objectSpread({
        trigger: 'item',
        formatter: formatTooltip
      }, _commonStyles.TOOLTIP_DEFAULT_PROPS)
    };
  };
  return /*#__PURE__*/_react["default"].createElement(_core2["default"], {
    echarts: echarts,
    option: options(),
    style: {
      width: '99.9%'
    },
    opts: {
      renderer: 'canvas',
      width: width !== null && width !== void 0 ? width : 'auto'
    }
  });
};
var _default = exports["default"] = RadarChart;