"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");
var _typeof3 = require("@babel/runtime/helpers/typeof");
Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;
var _toConsumableArray2 = _interopRequireDefault(require("@babel/runtime/helpers/toConsumableArray"));
var _defineProperty2 = _interopRequireDefault(require("@babel/runtime/helpers/defineProperty"));
var _typeof2 = _interopRequireDefault(require("@babel/runtime/helpers/typeof"));
var _toArray2 = _interopRequireDefault(require("@babel/runtime/helpers/toArray"));
var _react = _interopRequireDefault(require("react"));
var _charts = require("echarts/charts");
var _components = require("echarts/components");
var echarts = _interopRequireWildcard(require("echarts/core"));
var _renderers = require("echarts/renderers");
var _core2 = _interopRequireDefault(require("echarts-for-react/lib/core"));
var _ramda = require("ramda");
var _auxiliarFunctions = require("../../lib/auxiliarFunctions");
var _commonStyles = require("../../commonStyles");
var _theme = require("flipper-ui/theme");
function _interopRequireWildcard(e, t) { if ("function" == typeof WeakMap) var r = new WeakMap(), n = new WeakMap(); return (_interopRequireWildcard = function _interopRequireWildcard(e, t) { if (!t && e && e.__esModule) return e; var o, i, f = { __proto__: null, "default": e }; if (null === e || "object" != _typeof3(e) && "function" != typeof e) return f; if (o = t ? n : r) { if (o.has(e)) return o.get(e); o.set(e, f); } for (var _t in e) "default" !== _t && {}.hasOwnProperty.call(e, _t) && ((i = (o = Object.defineProperty) && Object.getOwnPropertyDescriptor(e, _t)) && (i.get || i.set) ? o(f, _t, i) : f[_t] = e[_t]); return f; })(e, t); }
function ownKeys(e, r) { var t = Object.keys(e); if (Object.getOwnPropertySymbols) { var o = Object.getOwnPropertySymbols(e); r && (o = o.filter(function (r) { return Object.getOwnPropertyDescriptor(e, r).enumerable; })), t.push.apply(t, o); } return t; }
function _objectSpread(e) { for (var r = 1; r < arguments.length; r++) { var t = null != arguments[r] ? arguments[r] : {}; r % 2 ? ownKeys(Object(t), !0).forEach(function (r) { (0, _defineProperty2["default"])(e, r, t[r]); }) : Object.getOwnPropertyDescriptors ? Object.defineProperties(e, Object.getOwnPropertyDescriptors(t)) : ownKeys(Object(t)).forEach(function (r) { Object.defineProperty(e, r, Object.getOwnPropertyDescriptor(t, r)); }); } return e; }
var _theme$colors = _theme.theme.colors,
  gray = _theme$colors.gray,
  neutral = _theme$colors.neutral;
echarts.use([_components.GridComponent, _components.TitleComponent, _renderers.CanvasRenderer, _components.LegendComponent, _components.TooltipComponent, _components.ToolboxComponent, _charts.BarChart, _charts.LineChart, _components.DataZoomInsideComponent, _components.DataZoomSliderComponent]);
var StackedBarChart = function StackedBarChart(props) {
  var _tooltip$extraResult, _toolboxTooltip$saveA, _toolboxTooltip$dataV;
  var data = props.data,
    grid = props.grid,
    xType = props.xType,
    width = props.width,
    title = props.title,
    colors = props.colors,
    tooltip = props.tooltip,
    barWidth = props.barWidth,
    dateFormat = props.dateFormat,
    legendType = props.legendType,
    yComplement = props.yComplement,
    tooltipExtra = props.tooltipExtra,
    showBarLabel = props.showBarLabel,
    sumDataValues = props.sumDataValues,
    toolboxTooltip = props.toolboxTooltip,
    legendScrollGap = props.legendScrollGap,
    secondYAxisType = props.secondYAxisType,
    additionalResults = props.additionalResults;
  var label = tooltip === null || tooltip === void 0 ? void 0 : tooltip.label;
  var topResult = tooltip === null || tooltip === void 0 ? void 0 : tooltip.topResult;
  var auxResult = tooltip === null || tooltip === void 0 ? void 0 : tooltip.auxResult;
  var lineResult = tooltip === null || tooltip === void 0 ? void 0 : tooltip.lineResult;
  var complement = tooltip === null || tooltip === void 0 ? void 0 : tooltip.complement;
  var bottomResult = tooltip === null || tooltip === void 0 ? void 0 : tooltip.bottomResult;
  var extraResult = (_tooltip$extraResult = tooltip === null || tooltip === void 0 ? void 0 : tooltip.extraResult) !== null && _tooltip$extraResult !== void 0 ? _tooltip$extraResult : '0';
  var _data = (0, _toArray2["default"])(data),
    bottomData = _data[0],
    topData = _data[1],
    _data$ = _data[2],
    lineData = _data$ === void 0 ? [] : _data$,
    extraData = _data[3],
    _data$2 = _data[4],
    auxData = _data$2 === void 0 ? [] : _data$2,
    additionalData = _data.slice(5);
  var yTopData = topData.map(_auxiliarFunctions.verifyStyleProps);
  var yLineData = lineData.map(function (item) {
    return item.result;
  });
  var yBottomData = bottomData.map(_auxiliarFunctions.verifyStyleProps);
  var yExtraData = data.length >= 4 && extraData.map(_auxiliarFunctions.verifyStyleProps);
  var yTopValue = yTopData.map(function (item) {
    return (0, _typeof2["default"])(item) === 'object' ? item.value : item;
  });
  var yBottomValue = yBottomData.map(function (item) {
    return (0, _typeof2["default"])(item) === 'object' ? item.value : item;
  });
  var topLabels = yBottomValue.map(function (item, index) {
    return item + yTopValue[index];
  });
  var xData = xType === 'time' ? bottomData.map(function (item) {
    return (0, _auxiliarFunctions.toDate)(item.label, dateFormat);
  }) : bottomData.map(function (item) {
    return item.label;
  });
  var formatLabel = function formatLabel(chartValues) {
    var dataIndex = chartValues.dataIndex;
    var value = topLabels[dataIndex];
    return (0, _auxiliarFunctions.takeLabelComplement)(Number(value), yComplement !== null && yComplement !== void 0 ? yComplement : '').toString();
  };
  var dynamicDataZoom = function dynamicDataZoom(item, charts) {
    var dataRange = item.end - item.start;
    var dataLimit = 1200 / xData.length;
    var fullLabel = 500 / xData.length;
    if (xData.length <= 5 || dataRange < fullLabel) {
      charts.setOption(_auxiliarFunctions.fullText);
    } else if (xData.length <= 14 || dataRange < dataLimit) {
      charts.setOption(_auxiliarFunctions.normalLabel);
    } else if (dataRange < 40) {
      charts.setOption(_auxiliarFunctions.rotatedLabel);
    } else {
      charts.setOption(_auxiliarFunctions.dontShowLabel);
    }
  };
  var formatTooltip = function formatTooltip(values) {
    var takeValue = function takeValue(data) {
      return (0, _typeof2["default"])(data) === 'object' ? Number(data.value) : Number(data);
    };
    var valueBot = values[0] ? takeValue(values[0].data) : 0;
    var valueTop = values[1] ? takeValue(values[1].data) : 0;
    var stackedValues = valueBot + valueTop;

    // This function is only used to show auxiliary values on tooltip.
    // We need to improve this component to allow users use it better.
    var getAuxToolTip = function getAuxToolTip(dataIndex) {
      return auxData.length && auxData[dataIndex].result >= 0 ? (0, _auxiliarFunctions.generateAuxMessage)(auxResult !== null && auxResult !== void 0 ? auxResult : '', auxData[dataIndex].result, yComplement !== null && yComplement !== void 0 ? yComplement : '') : '';
    };
    var tooltipValues = values.map(function (value) {
      return yComplement === 'time' ? (0, _auxiliarFunctions.monuntTimeMessage)(value, stackedValues) : (0, _auxiliarFunctions.mountMessage)(value, yComplement !== null && yComplement !== void 0 ? yComplement : '', secondYAxisType !== null && secondYAxisType !== void 0 ? secondYAxisType : '', stackedValues, sumDataValues !== null && sumDataValues !== void 0 ? sumDataValues : false);
    });
    var auxTooltip = [getAuxToolTip(values[0].dataIndex)];
    var tooltipBody = auxData.length > 0 && auxResult ? (0, _ramda.move)(3, 4, (0, _ramda.concat)(tooltipValues, auxTooltip)).join('') : tooltipValues.join('');
    var isMoney = function isMoney(complement) {
      return typeof yComplement === 'function' ? yComplement(stackedValues) : "".concat(stackedValues, " ").concat(complement);
    };
    var verifyFormat = yComplement === 'time' ? (0, _auxiliarFunctions.timeConvert)(stackedValues) : isMoney(yComplement !== null && yComplement !== void 0 ? yComplement : '');
    var labelResult = xType === 'time' ? label + ': ' + (0, _auxiliarFunctions.formatTime)(values[0].name, 'MMM/yy') + '<br>' : label + ': ' + values[0].name + '<br>';
    var valueWithoutSecondYAxis = sumDataValues && values.length === 2 && !secondYAxisType ? complement + ': ' + verifyFormat : '';
    var tooltipSumValues = sumDataValues && values.length === 3 && secondYAxisType && typeof yComplement === 'function' ? complement + ': ' + yComplement(stackedValues) : valueWithoutSecondYAxis;
    var tooltipFooter = tooltipExtra && !sumDataValues ? tooltipExtra : tooltipSumValues;
    return labelResult + tooltipBody + tooltipFooter;
  };
  var secondYAxis = secondYAxisType === 'percent' ? {
    type: 'value',
    position: 'right',
    min: 0,
    max: 100,
    axisLine: {
      show: true,
      lineStyle: {
        color: colors === null || colors === void 0 ? void 0 : colors[2]
      }
    },
    axisLabel: _objectSpread(_objectSpread({}, _commonStyles.COMMON_STYLE), {}, {
      color: colors === null || colors === void 0 ? void 0 : colors[2],
      formatter: function formatter(item) {
        return (0, _auxiliarFunctions.takeLabelComplement)(Number(item), '%');
      }
    }),
    axisTick: {
      show: true
    },
    splitLine: {
      show: false
    }
  } : {};
  var zoomEvent = {
    dataZoom: dynamicDataZoom
  };
  var scrollable = data[0].length > 12 ? [{
    type: 'inside',
    zoomLock: true,
    zoomOnMouseWheel: 'shift',
    endValue: xData.length > 12 ? xData[11] : xData[xData.length - 1]
  }, {
    type: 'slider',
    show: true,
    endValue: xData.length > 12 ? xData[11] : xData[xData.length - 1]
  }] : [];
  var extraStackedSerie = yExtraData && {
    type: 'bar',
    yAxisIndex: 0,
    stack: 'stacked',
    data: yExtraData,
    name: extraResult,
    barWidth: barWidth
  };
  var additionalResultsMap = additionalResults ? additionalResults.map(function (it) {
    return it.name;
  }) : [];
  var aditionalSeries = additionalData.map(function (it, i) {
    return (additionalResults === null || additionalResults === void 0 ? void 0 : additionalResults[i].type) === 'bar' ? {
      type: 'bar',
      stack: 'stacked',
      yAxisIndex: 0,
      barWidth: barWidth,
      data: it.map(_auxiliarFunctions.verifyStyleProps),
      name: additionalResults[i].name
    } : {
      type: 'line',
      data: it.map(_auxiliarFunctions.verifyStyleProps),
      name: additionalResults === null || additionalResults === void 0 ? void 0 : additionalResults[i].name,
      yAxisIndex: secondYAxisType === 'percent' ? 1 : 0
    };
  });
  var series = [{
    type: 'bar',
    stack: 'stacked',
    yAxisIndex: 0,
    data: yTopData,
    name: topResult,
    barWidth: barWidth
  }, {
    type: 'bar',
    stack: 'stacked',
    yAxisIndex: 0,
    data: yBottomData,
    barWidth: barWidth,
    name: bottomResult,
    label: {
      distance: 2,
      fontSize: 12,
      position: 'top',
      show: showBarLabel,
      formatter: formatLabel,
      color: neutral[200]
    }
  }, extraStackedSerie, {
    type: 'line',
    data: yLineData,
    name: lineResult,
    yAxisIndex: secondYAxisType === 'percent' ? 1 : 0
  }].concat((0, _toConsumableArray2["default"])(aditionalSeries));
  var legendProps = legendType === 'scroll' ? {
    top: 270,
    type: legendType,
    itemGap: legendScrollGap || 60,
    data: [topResult, bottomResult, extraResult, lineResult].concat((0, _toConsumableArray2["default"])(additionalResultsMap)),
    textStyle: _objectSpread({}, _commonStyles.LEGEND_STYLE)
  } : {
    top: 30,
    itemGap: 30,
    data: [topResult, bottomResult, extraResult, lineResult].concat((0, _toConsumableArray2["default"])(additionalResultsMap)),
    textStyle: _objectSpread({}, _commonStyles.LEGEND_STYLE)
  };
  var toolbox = toolboxTooltip && {
    showTitle: false,
    right: '8.7%',
    feature: {
      saveAsImage: toolboxTooltip.saveAsImage && (0, _auxiliarFunctions.getSaveAsImage)((_toolboxTooltip$saveA = toolboxTooltip.saveAsImage.title) !== null && _toolboxTooltip$saveA !== void 0 ? _toolboxTooltip$saveA : ''),
      dataView: toolboxTooltip.dataView && (0, _auxiliarFunctions.getDataView)((_toolboxTooltip$dataV = toolboxTooltip.dataView.title) !== null && _toolboxTooltip$dataV !== void 0 ? _toolboxTooltip$dataV : '')
    }
  };
  var options = function options() {
    return {
      grid: grid,
      color: colors,
      series: series,
      dataZoom: scrollable,
      title: {
        text: title,
        top: legendType === 'scroll' && '5.7%',
        left: legendType === 'scroll' ? '0.1%' : '4%',
        textStyle: _objectSpread({}, _commonStyles.TITLE_STYLE)
      },
      xAxis: {
        data: xData,
        type: 'category',
        boundaryGap: true,
        splitLine: {
          show: true,
          alignWithLabel: true,
          lineStyle: {
            opacity: 0.3,
            color: gray[800]
          }
        },
        axisLabel: _objectSpread(_objectSpread({}, _commonStyles.COMMON_STYLE), {}, {
          fontSize: xData.length > 14 ? 10 : 11.5,
          interval: xData.length > 20 ? 'auto' : 0,
          formatter: function formatter(item) {
            return xType === 'time' ? (0, _auxiliarFunctions.formatTime)(item, 'MMM/yy') : (0, _auxiliarFunctions.truncateLabel)(item);
          }
        }),
        axisTick: {
          show: true,
          alignWithLabel: true
        }
      },
      yAxis: [{
        type: 'value',
        position: 'left',
        min: 0,
        splitLine: {
          show: true,
          lineStyle: {
            opacity: 0.3,
            color: gray[800]
          }
        },
        axisLabel: _objectSpread(_objectSpread({}, _commonStyles.LEGEND_STYLE), {}, {
          formatter: function formatter(item) {
            return (0, _auxiliarFunctions.takeLabelComplement)(Number(item), yComplement !== null && yComplement !== void 0 ? yComplement : '').toString();
          }
        }),
        axisLine: {
          show: true
        },
        axisTick: {
          show: true,
          alignWithLabel: true
        }
      }, secondYAxis],
      legend: legendType === 'none' ? {
        show: false
      } : legendProps,
      tooltip: tooltip && _objectSpread({
        trigger: 'axis',
        formatter: formatTooltip
      }, _commonStyles.TOOLTIP_DEFAULT_PROPS),
      toolbox: _objectSpread(_objectSpread({}, toolbox), {}, {
        tooltip: _objectSpread(_objectSpread({}, _commonStyles.TOOLTIP_DEFAULT_PROPS), {}, {
          formatter: function formatter(param) {
            return "<div>".concat(param.title, "</div>");
          }
        })
      })
    };
  };
  return /*#__PURE__*/_react["default"].createElement(_core2["default"], {
    notMerge: true,
    echarts: echarts,
    option: options(),
    style: {
      width: '99.9%'
    },
    opts: {
      renderer: 'canvas',
      width: width !== null && width !== void 0 ? width : 'auto'
    },
    onEvents: zoomEvent
  });
};
var _default = exports["default"] = StackedBarChart;