"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");
var _typeof = require("@babel/runtime/helpers/typeof");
Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;
var _defineProperty2 = _interopRequireDefault(require("@babel/runtime/helpers/defineProperty"));
var _toConsumableArray2 = _interopRequireDefault(require("@babel/runtime/helpers/toConsumableArray"));
var _react = _interopRequireDefault(require("react"));
var _charts = require("echarts/charts");
var _components = require("echarts/components");
var echarts = _interopRequireWildcard(require("echarts/core"));
var _renderers = require("echarts/renderers");
var _core2 = _interopRequireDefault(require("echarts-for-react/lib/core"));
var _auxiliarFunctions = require("../../lib/auxiliarFunctions");
var _commonStyles = require("../../commonStyles");
function _interopRequireWildcard(e, t) { if ("function" == typeof WeakMap) var r = new WeakMap(), n = new WeakMap(); return (_interopRequireWildcard = function _interopRequireWildcard(e, t) { if (!t && e && e.__esModule) return e; var o, i, f = { __proto__: null, "default": e }; if (null === e || "object" != _typeof(e) && "function" != typeof e) return f; if (o = t ? n : r) { if (o.has(e)) return o.get(e); o.set(e, f); } for (var _t in e) "default" !== _t && {}.hasOwnProperty.call(e, _t) && ((i = (o = Object.defineProperty) && Object.getOwnPropertyDescriptor(e, _t)) && (i.get || i.set) ? o(f, _t, i) : f[_t] = e[_t]); return f; })(e, t); }
function ownKeys(e, r) { var t = Object.keys(e); if (Object.getOwnPropertySymbols) { var o = Object.getOwnPropertySymbols(e); r && (o = o.filter(function (r) { return Object.getOwnPropertyDescriptor(e, r).enumerable; })), t.push.apply(t, o); } return t; }
function _objectSpread(e) { for (var r = 1; r < arguments.length; r++) { var t = null != arguments[r] ? arguments[r] : {}; r % 2 ? ownKeys(Object(t), !0).forEach(function (r) { (0, _defineProperty2["default"])(e, r, t[r]); }) : Object.getOwnPropertyDescriptors ? Object.defineProperties(e, Object.getOwnPropertyDescriptors(t)) : ownKeys(Object(t)).forEach(function (r) { Object.defineProperty(e, r, Object.getOwnPropertyDescriptor(t, r)); }); } return e; }
echarts.use([_components.GridComponent, _components.TitleComponent, _renderers.CanvasRenderer, _components.TooltipComponent, _components.ToolboxComponent, _charts.BarChart, _components.DataZoomInsideComponent, _components.DataZoomSliderComponent]);
var VerticalBarChart = function VerticalBarChart(props) {
  var _toolboxTooltip$saveA, _toolboxTooltip$dataV;
  var grid = props.grid,
    data = props.data,
    color = props.color,
    xType = props.xType,
    yType = props.yType,
    width = props.width,
    title = props.title,
    tooltip = props.tooltip,
    barWidth = props.barWidth,
    interval = props.interval,
    dateFormat = props.dateFormat,
    rotateLabel = props.rotateLabel,
    yComplement = props.yComplement,
    scrollStart = props.scrollStart,
    showBarLabel = props.showBarLabel,
    titleFontSize = props.titleFontSize,
    toolboxTooltip = props.toolboxTooltip,
    customMaxDomain = props.customMaxDomain,
    marginLeftTitle = props.marginLeftTitle,
    tooltipComplement = props.tooltipComplement,
    marginRightToolbox = props.marginRightToolbox,
    isMoreThanHundredPercent = props.isMoreThanHundredPercent,
    onClickBar = props.onClickBar;
  var isCustomDomain = customMaxDomain ? customMaxDomain : _auxiliarFunctions.getDomain;
  var xData = data.map(function (item) {
    return item.label;
  });
  var yData = data.map(function (item) {
    var results = data.map(function (item) {
      return item.result;
    });
    var maxValue = Math.max.apply(Math, (0, _toConsumableArray2["default"])(results));
    var label = showBarLabel && item.result <= 10 ? {
      position: 'top',
      distance: 1
    } : false;
    if (maxValue !== item.result) {
      var mainPercentage = item.result * 100 / maxValue;
      var _label = mainPercentage < 15 ? {
        position: 'top',
        distance: 1
      } : {};
      return {
        value: item.result,
        label: _label,
        itemStyle: item.style,
        itemId: item.itemId && item.itemId
      };
    }
    return {
      value: item.result,
      label: label,
      itemStyle: item.style,
      itemId: item.itemId && item.itemId
    };
  });
  var specialLabel = function specialLabel(item) {
    return (0, _auxiliarFunctions.fixedTruncateLabel)(item, xData.length <= 5 ? 16 : 9);
  };
  var dynamicDataZoom = function dynamicDataZoom(item, charts) {
    var dataRange = item.end - item.start;
    var fullLabel = 500 / xData.length;
    var minimum = 800 / xData.length;
    if (rotateLabel) {
      if (xData.length <= 5 || dataRange < minimum) {
        charts.setOption(_auxiliarFunctions.fullText);
      } else {
        if (dataRange > fullLabel && xData.length <= 40) {
          charts.setOption((0, _auxiliarFunctions.rotatedLabelSpecial)(rotateLabel));
        } else {
          charts.setOption(_auxiliarFunctions.dontShowLabel);
        }
      }
    } else {
      var dataLimit = 1200 / xData.length;
      if (xData.length <= 5 || dataRange < fullLabel) {
        charts.setOption(_auxiliarFunctions.fullText);
      } else if (xData.length <= 12 || dataRange < dataLimit) {
        charts.setOption(_auxiliarFunctions.normalLabel);
      } else if (dataRange < 40) {
        charts.setOption(_auxiliarFunctions.rotatedLabel);
      } else {
        charts.setOption(_auxiliarFunctions.dontShowLabel);
      }
    }
  };
  var formatLabel = function formatLabel(chartValues) {
    var value = chartValues.value;
    var isTimeType = yType === 'time';
    return isTimeType ? (0, _auxiliarFunctions.timeConvert)(Number(value)) + 'h' : String((0, _auxiliarFunctions.takeLabelComplement)(Number(value), yComplement !== null && yComplement !== void 0 ? yComplement : ''));
  };
  var formatSingleTooltip = function formatSingleTooltip(chartValues) {
    var _chartValues$ = chartValues[0],
      axisValueLabel = _chartValues$.axisValueLabel,
      value = _chartValues$.value;
    var label = tooltip === null || tooltip === void 0 ? void 0 : tooltip.label;
    var result = tooltip === null || tooltip === void 0 ? void 0 : tooltip.result;
    var complement = tooltipComplement ? tooltipComplement : '';
    var values = yType === 'time' ? (0, _auxiliarFunctions.timeConvert)(Number(value)) + 'h' : (0, _auxiliarFunctions.takeLabelComplement)(Number(value), yComplement !== null && yComplement !== void 0 ? yComplement : '');
    var labelPrint = xType === 'time' ? (0, _auxiliarFunctions.formatTooltip)(axisValueLabel, dateFormat) : axisValueLabel;
    return "".concat(label, ": ").concat(labelPrint, " <br>") + "".concat(result, ": ").concat(values, " <br>") + complement;
  };
  var events = {
    dataZoom: dynamicDataZoom,
    click: onClickBar !== null && onClickBar !== void 0 ? onClickBar : function () {}
  };
  var series = [{
    type: 'bar',
    data: yData,
    barWidth: barWidth || 'auto',
    label: _objectSpread(_objectSpread({}, _commonStyles.LEGEND_STYLE), {}, {
      distance: 6,
      fontSize: 12,
      show: showBarLabel,
      position: 'insideTop',
      formatter: formatLabel
    })
  }];
  var arrayInitialSize = scrollStart || (dateFormat === 'yyyy-MM' ? 12 : 30);
  var scrollable = data.length > arrayInitialSize ? [{
    type: 'inside',
    start: (0, _auxiliarFunctions.getInitialValues)(xData.length, dateFormat, scrollStart),
    endValue: xData.length > 12 ? xData[11] : xData[xData.length - 1],
    zoomOnMouseWheel: 'shift'
  }, {
    show: true,
    type: 'slider',
    start: (0, _auxiliarFunctions.getInitialValues)(xData.length, dateFormat, scrollStart),
    endValue: xData.length > 12 ? xData[11] : xData[xData.length - 1]
  }] : [];
  var toolbox = toolboxTooltip && {
    showTitle: false,
    right: marginRightToolbox || '8.7%',
    feature: {
      saveAsImage: toolboxTooltip.saveAsImage && (0, _auxiliarFunctions.getSaveAsImage)((_toolboxTooltip$saveA = toolboxTooltip.saveAsImage.title) !== null && _toolboxTooltip$saveA !== void 0 ? _toolboxTooltip$saveA : ''),
      dataView: toolboxTooltip.dataView && (0, _auxiliarFunctions.getDataView)((_toolboxTooltip$dataV = toolboxTooltip.dataView.title) !== null && _toolboxTooltip$dataV !== void 0 ? _toolboxTooltip$dataV : '')
    }
  };
  var options = function options() {
    return {
      interval: interval,
      series: series,
      grid: _objectSpread({}, grid),
      dataZoom: scrollable,
      color: color && [color],
      title: {
        text: title,
        left: marginLeftTitle || '5.9%',
        textStyle: _objectSpread(_objectSpread({}, _commonStyles.TITLE_STYLE), {}, {
          fontSize: titleFontSize || 16
        })
      },
      xAxis: {
        type: 'category',
        data: xData,
        showGrid: true,
        boundaryGap: true,
        splitLine: {
          show: true,
          alignWithLabel: true,
          lineStyle: _objectSpread({}, _commonStyles.AXIS_SPLIT_LINE)
        },
        axisLabel: _objectSpread(_objectSpread({}, _commonStyles.LEGEND_STYLE), {}, {
          interval: 0,
          fontSize: 11,
          rotate: rotateLabel && rotateLabel,
          formatter: function formatter(item) {
            return xType === 'time' ? (0, _auxiliarFunctions.formatTime)(item, (0, _auxiliarFunctions.getDateFormatType)(dateFormat !== null && dateFormat !== void 0 ? dateFormat : 'yyyy-MM', 'dd/MM/yyyy')) : specialLabel(item);
          }
        }),
        axisTick: {
          show: true,
          alignWithLabel: true
        }
      },
      yAxis: {
        type: 'value',
        splitLine: {
          show: true,
          lineStyle: _objectSpread({}, _commonStyles.AXIS_SPLIT_LINE)
        },
        axisLabel: _objectSpread(_objectSpread({}, _commonStyles.LEGEND_STYLE), {}, {
          fontSize: 11,
          formatter: function formatter(item) {
            return yType === 'time' ? (0, _auxiliarFunctions.timeConvert)(item) + 'h' : String((0, _auxiliarFunctions.takeLabelComplement)(item, yComplement !== null && yComplement !== void 0 ? yComplement : ''));
          }
        }),
        axisLine: {
          show: true
        },
        axisTick: {
          show: true,
          alignWithLabel: true
        },
        max: !isMoreThanHundredPercent && yComplement === '%' ? 100 : isCustomDomain
      },
      tooltip: tooltip && _objectSpread({
        trigger: 'axis',
        formatter: formatSingleTooltip
      }, _commonStyles.TOOLTIP_DEFAULT_PROPS),
      toolbox: _objectSpread(_objectSpread({}, toolbox), {}, {
        tooltip: _objectSpread(_objectSpread({}, _commonStyles.TOOLTIP_DEFAULT_PROPS), {}, {
          formatter: function formatter(param) {
            return "<div>".concat(param.title, "</div>");
          }
        })
      })
    };
  };
  return /*#__PURE__*/_react["default"].createElement(_core2["default"], {
    notMerge: true,
    lazyUpdate: true,
    echarts: echarts,
    option: options(),
    style: {
      width: '99.9%'
    },
    opts: {
      renderer: 'canvas',
      width: width !== null && width !== void 0 ? width : 'auto'
    },
    onEvents: events
  });
};
var _default = exports["default"] = VerticalBarChart;