import type { Complement, ConnectedDataURL, DataTooltip, DomainValues, EntryData, TypeChart, WidthProps } from '../core/types';
export declare const DOWNLOAD_ICON: string;
export declare const DATA_VIEW_ICON: string;
export declare const ICON_STYLE: {
    color: string;
    borderColor: string;
    borderWidth: number;
};
export declare const timeConvert: (value: number) => string;
export declare const getPercentage: (value: number, valueTotal: number) => string;
export declare const takeLabelComplement: (item: number, yComplement: Complement, typeChart?: TypeChart) => string | number;
export declare const takeDonutChartComplement: (item: number, complement?: Complement) => string;
export declare const generateAuxMessage: (label: string, result: number, complement: Complement) => string;
export declare const monuntTimeMessage: (item: DataTooltip, stackedValues: number) => string;
export declare const mountMessage: (value: DataTooltip, complement: Complement, axisType: string, stackedValues: number, sumDataValues: boolean) => string;
export declare const getDateFormatType: (dateFormat: string, baseFormat?: string) => string;
export declare const toArgDateFns: (date: Date | number | string) => number | Date;
export declare const formatTime: (text: string, dateFormat?: string) => string;
export declare const toDate: (text: string, format?: string) => Date;
export declare const formatTooltip: (text: string, dateFormat?: string) => string;
export declare const formatTooltipWithHours: (text: string) => string;
export declare const truncateLabel: (text: string, labelWordSize?: number) => string;
export declare const fixedTruncateLabel: (text: string, size: number) => string;
export declare const getDomain: (item: DomainValues) => number;
export declare const fixedDomain: (item: DomainValues) => number;
export declare const getSaveAsImage: (title: string, name?: string) => {
    title: string;
    name: string | undefined;
    type: string;
    show: boolean;
    icon: string;
    iconStyle: {
        color: string;
        borderColor: string;
        borderWidth: number;
    };
    excludeComponents: string[];
};
export declare const getDataView: (title: string) => {
    title: string;
    show: boolean;
    icon: string;
    iconStyle: {
        color: string;
        borderColor: string;
        borderWidth: number;
    };
    buttonColor: string;
    lang: string[];
};
export declare const getInitialValues: (arrayLength: number, dateFormat?: string, scrollStart?: number) => number;
export declare const thousandSeparator: (values: string | number) => string;
export declare const getSaveAsImageWithTitle: (title: string, setTitle: (show: boolean) => void, name?: string) => {
    title: string;
    name: string | undefined;
    show: boolean;
    icon: string;
    iconStyle: {
        color: string;
        borderColor: string;
        borderWidth: number;
    };
    onclick: (item: {
        option: {
            title: {
                text: string;
            }[];
        };
    }, chartInfo: {
        getConnectedDataURL: (opts: ConnectedDataURL) => string;
    }) => void;
};
export declare const getWidthOpts: (width: WidthProps) => {
    width: WidthProps;
};
export declare const convertImageToBase64FromUrl: (imgUrl: string) => Promise<unknown>;
export declare const changeSpaceForUnderline: (value: string) => string;
export declare const formatLabelWithImage: (text: string) => string;
export declare const verifyStyleProps: (data: EntryData) => number | {
    value: number;
    itemStyle: import("../core/types").LabelProps;
};
export declare const dontShowLabel: {
    grid: {
        bottom: number;
    };
    xAxis: {
        axisLabel: {
            interval: number;
            rotate: number;
        };
    };
};
export declare const normalLabel: {
    grid: {
        bottom: number;
    };
    xAxis: {
        axisLabel: {
            show: boolean;
            rotate: number;
            interval: number;
            formatter: (item: string) => string;
        };
    };
};
export declare const fullText: {
    grid: {
        bottom: number;
    };
    xAxis: {
        axisLabel: {
            show: boolean;
            rotate: number;
            interval: number;
            formatter: (item: string) => string;
        };
    };
};
export declare const rotatedLabel: {
    grid: {
        bottom: number;
    };
    xAxis: {
        axisLabel: {
            show: boolean;
            rotate: number;
            interval: number;
            formatter: (item: string) => string;
        };
    };
};
export declare const rotatedLabelSpecial: (rotate: number) => {
    grid: {
        bottom: number;
    };
    xAxis: {
        axisLabel: {
            show: boolean;
            interval: number;
            rotate: number;
            textStyle: {
                fontSize: number;
            };
            formatter: (item: string) => string;
        };
    };
};
